import*as React from'react';import {useState,useEffect}from'react';import moment from'moment';import {CSVLink}from'react-csv';import {useTimeformat}from'../timetracker/hooks/index.js';import {roundDuration,formatDuration}from'../timetracker/services/timeRecordService.js';import'tslib';import {capitalize}from'../utils/calculate.js';const ExportReportAsCSV = (props) => {
    const { groupBy, groupByRecords, calcDurationReducer, roundType, roundValue, rounded } = props;
    const [headers, setHeaders] = useState([]);
    const [data, setData] = useState([]);
    const { timeFormat } = useTimeformat();
    useEffect(() => {
        setHeaders([
            { label: capitalize(groupBy), key: groupBy },
            { label: 'Time(h)', key: 'time_h' },
            { label: 'Time(decimal)', key: 'time_dec' },
        ]);
    }, [groupBy]);
    useEffect(() => {
        const reportData = groupByRecords.map((item) => {
            const { time_h, time_dec } = getTotalTime(item.records);
            return { [groupBy]: item.name, time_h, time_dec };
        });
        setData(reportData);
    }, [JSON.stringify(groupByRecords), rounded, roundValue, roundType, timeFormat]);
    const getTotalTime = (pRecords) => {
        const pTotalDur = pRecords.reduce(calcDurationReducer, 0);
        const time = rounded ? roundDuration(pTotalDur, roundValue, roundType) : pTotalDur;
        const time_h = formatDuration(time, timeFormat);
        const time_dec = moment.duration(time_h).asHours().toFixed(2);
        return { time_h, time_dec };
    };
    return (React.createElement(CSVLink, { data: data, headers: headers }, "Save as CSV"));
};export{ExportReportAsCSV};//# sourceMappingURL=ExportReportAsCSV.js.map
