import*as React from'react';import {useState,useEffect}from'react';import ReactExport from'react-export-excel';import moment from'moment';import {useTimeformat}from'../timetracker/hooks/index.js';import {formatDuration,roundDuration}from'../timetracker/services/timeRecordService.js';import'tslib';import {capitalize}from'../utils/calculate.js';const ExcelFile = ReactExport.ExcelFile;
const ExcelSheet = ReactExport.ExcelFile.ExcelSheet;
const ExportReportAsExcel = (props) => {
    const { groupBy, groupByRecords, calcDurationReducer, range, roundType, roundValue, rounded } = props;
    const [columns, setColumns] = useState([]);
    const [data, setData] = useState([]);
    const { timeFormat, dateFormat } = useTimeformat();
    useEffect(() => {
        setColumns([capitalize(groupBy), 'Time(h)', 'Time(decimal)']);
    }, [groupBy]);
    useEffect(() => {
        let timeData = [];
        const durArray = groupByRecords.map((item) => {
            const { time, time_h, time_dec } = getTotalTime(item.records);
            timeData.push(time);
            return [item.name, time_h, time_dec];
        });
        const duration = `${moment(range.start).format(dateFormat)} - ${moment(range.end).format(dateFormat)}`;
        const totalTime = formatDuration(timeData.length && timeData.reduce((accumulator, currentValue) => accumulator + currentValue), timeFormat);
        durArray.push([`Total (${duration})`, totalTime, moment.duration(totalTime).asHours().toFixed(2)]);
        setData(durArray);
    }, [
        JSON.stringify(groupByRecords),
        range,
        dateFormat,
        timeFormat,
        rounded,
        roundType,
        roundValue,
    ]);
    const getTotalTime = (pRecords) => {
        const pTotalDur = pRecords.reduce(calcDurationReducer, 0);
        const time = rounded ? roundDuration(pTotalDur, roundValue, roundType) : pTotalDur;
        const time_h = formatDuration(time, timeFormat);
        const time_dec = moment.duration(time_h).asHours().toFixed(2);
        return { time, time_h, time_dec };
    };
    return (React.createElement(ExcelFile, { element: React.createElement("div", null, "Save as Excel") },
        React.createElement(ExcelSheet, { dataSet: [{ columns, data }], name: "Report" })));
};export{ExportReportAsExcel};//# sourceMappingURL=ExportReportAsExcel.js.map
