import*as React from'react';import {useFela}from'react-fela';import {Divider,Table}from'antd';import {BarChart}from'./BarChart.js';import {DoughnutChart}from'./DoughnutChart.js';import moment from'moment';import {useTimeformat}from'../timetracker/hooks/index.js';import {formatDuration}from'../timetracker/services/timeRecordService.js';const ExportReportAsPDF = (props) => {
    const { range, generateBarData, generateLabels, generateProjectLabels, generateProjectDurations, generateDatasource, generateTableColumns, getHeader, } = props;
    const { css } = useFela();
    const { dateFormat, timeFormat } = useTimeformat();
    const totalTime = generateProjectDurations().length &&
        generateProjectDurations().reduce((accumulator, currentValue) => accumulator + currentValue);
    return (React.createElement("div", { className: css(styles.container) },
        React.createElement("div", { id: 'projects-report' },
            React.createElement("div", { className: css(styles.title) }, "Summary Report"),
            React.createElement("div", { className: css(styles.label) }, `${moment(range.start).format(dateFormat)} - ${moment(range.end).add(6, 'day').format(dateFormat)}`),
            React.createElement("div", { className: css(styles.duration) },
                React.createElement("span", { className: css(styles.label) }, "Total:"),
                React.createElement("span", { className: css(styles.value) }, formatDuration(totalTime, timeFormat)),
                getHeader(styles.label, styles.value)),
            React.createElement("div", { className: css(styles.barWrapper) },
                React.createElement(BarChart, { title: "Reports", data: generateBarData(), labels: generateLabels() })),
            React.createElement(Divider, { className: css(styles.divider), orientation: 'left' }, "Project"),
            React.createElement("div", { className: css(styles.doughnutWrapper) },
                React.createElement(DoughnutChart, { title: "Reports", data: generateProjectDurations(), labels: generateProjectLabels() })),
            React.createElement(Divider, { className: css(styles.divider) }),
            React.createElement("div", null,
                React.createElement(Table, { rowKey: "id", dataSource: generateDatasource(), columns: generateTableColumns(), pagination: false })))));
};
const styles = {
    container: () => ({
        width: '100%',
        opacity: '0',
    }),
    title: () => ({
        fontSize: '36px',
    }),
    duration: () => ({
        margin: '5px 0px',
    }),
    label: () => ({
        color: '#696868',
        fontSize: '18px',
    }),
    value: () => ({
        fontSize: '22px',
        fontWeight: '500',
        marginLeft: '5px',
        marginRight: '50px',
    }),
    barWrapper: () => ({
        width: '100%',
        margin: '70px 0px',
    }),
    doughnutWrapper: () => ({
        width: '50%',
    }),
    tableWrapper: () => ({
        margin: '0 80px',
    }),
    divider: () => ({
        margin: '30px 0px !important',
        borderTopColor: '#929292 !important',
    }),
};export{ExportReportAsPDF};//# sourceMappingURL=ExportReportAsPDF.js.map
