import*as React from'react';import {useState,useEffect}from'react';import {useSelector}from'react-redux';import {useFela}from'react-fela';import {Menu,Input,Checkbox,Dropdown,Badge}from'antd';import {DownOutlined,CaretDownOutlined}from'@ant-design/icons';import {useGetOrganizationClientsQuery}from'@adminide-stack/account-api-client';import {styles}from'./styles.js';import {WITHOUT,FilterName}from'../ReportFilter.js';var Status;
(function (Status) {
    Status["ACTIVE"] = "Active";
    Status["ARCHIVED"] = "Archived";
    Status["ACTIVE_ARCHIVED"] = "Active & Archived";
})(Status || (Status = {}));
const ClientDropdown = (props) => {
    const { title, filteredData, setFilteredData } = props;
    const [visible, setVisible] = useState(false);
    const [show, setShow] = useState(false);
    const [checkedList, setCheckedList] = React.useState([]);
    const [checkAll, setCheckAll] = React.useState(false);
    const [status, setStatus] = useState(Status.ACTIVE);
    const [filteredClients, setFilteredClients] = useState([]);
    const [count, setCount] = useState(0);
    const { css } = useFela();
    const orgName = useSelector((state) => state.platform.orgName);
    const { data: { getOrganizationClients: clients } = {}, refetch } = useGetOrganizationClientsQuery();
    useEffect(() => {
        refetch();
    }, [orgName]);
    useEffect(() => {
        if (clients === null || clients === void 0 ? void 0 : clients.length) {
            setFilteredClients(clients);
        }
    }, [clients]);
    const handleVisibleChange = (value) => {
        if (!value) {
            setCount(checkedList.length);
            setFilteredData(Object.assign(Object.assign({}, filteredData), { [FilterName.CLIENT]: {
                    selectedIds: [...checkedList]
                } }));
        }
        setVisible(value);
    };
    const showStatus = () => {
        setShow(!show);
    };
    const onClickStatus = ({ key }) => {
        setStatus(key);
        setShow(false);
    };
    const onChange = list => {
        setCheckedList(list);
        setCheckAll(list.length === (clients.length + 1));
    };
    const onCheckAllChange = e => {
        let list = e.target.checked ? clients === null || clients === void 0 ? void 0 : clients.map(client => client.id) : [];
        if (e.target.checked) {
            list.push(WITHOUT);
        }
        setCheckedList(list);
        setCheckAll(e.target.checked);
    };
    const onChangeInput = (e) => {
        let newClients = [];
        if (e.target.value.trim()) {
            newClients = filterClients(e.target.value);
        }
        else {
            newClients = clients;
        }
        setFilteredClients(newClients);
    };
    const filterClients = (str) => {
        return clients === null || clients === void 0 ? void 0 : clients.filter((client) => {
            return client.displayName.toLowerCase().includes(str.toLowerCase());
        });
    };
    const content = (React.createElement(Menu, { className: css(styles.menu) },
        React.createElement(Menu.Item, { className: css(styles.item) },
            React.createElement(Input, { onChange: onChangeInput, placeholder: 'Find client...' })),
        React.createElement(Menu.Divider, { className: css(styles.divider) }),
        React.createElement(Menu.Item, { className: css(styles.item) },
            React.createElement("div", { style: { display: 'flex' } },
                React.createElement("div", { className: css(styles.label) }, "SHOW"),
                React.createElement("div", { style: { marginLeft: 'auto' }, onClick: showStatus },
                    React.createElement("a", null, status),
                    React.createElement(DownOutlined, { className: css(styles.icon) })))),
        React.createElement(Menu.Divider, { className: css(styles.divider) }),
        show ? (React.createElement(React.Fragment, null,
            React.createElement(Menu.Item, { className: css(styles.statusItem), key: Status.ACTIVE_ARCHIVED, onClick: onClickStatus },
                React.createElement("div", null, Status.ACTIVE_ARCHIVED)),
            React.createElement(Menu.Divider, { className: css(styles.divider) }),
            React.createElement(Menu.Item, { className: css(styles.statusItem), key: Status.ACTIVE, onClick: onClickStatus },
                React.createElement("div", null, Status.ACTIVE)),
            React.createElement(Menu.Divider, { className: css(styles.divider) }),
            React.createElement(Menu.Item, { className: css(styles.statusItem), key: Status.ARCHIVED, onClick: onClickStatus },
                React.createElement("div", null, Status.ARCHIVED)),
            React.createElement(Menu.Divider, { className: css(styles.divider) }))) : null,
        (filteredClients.length || (clients === null || clients === void 0 ? void 0 : clients.length)) ? (React.createElement(React.Fragment, null,
            React.createElement(Menu.Item, { className: css(styles.item) },
                React.createElement(Checkbox, { className: css(styles.checkbox), onChange: onCheckAllChange, checked: checkAll }, "Select all")),
            React.createElement(Menu.Divider, { className: css(styles.divider) }),
            React.createElement(Menu.Item, { className: css(styles.disabledItem) },
                React.createElement(Checkbox.Group, { className: css(styles.checkboxGroup), onChange: onChange, value: checkedList },
                    React.createElement(Menu, null,
                        React.createElement(Menu.Item, { key: WITHOUT, className: css(styles.item, styles.mTB0) },
                            React.createElement(Checkbox, { value: WITHOUT, className: css(styles.checkbox) }, 'Without client')), filteredClients === null || filteredClients === void 0 ? void 0 :
                        filteredClients.map((client, index) => (React.createElement(React.Fragment, { key: index },
                            React.createElement(Menu.Divider, { className: css(styles.divider) }),
                            React.createElement(Menu.Item, { key: client.id, className: css(styles.item, styles.mTB0) },
                                React.createElement(Checkbox, { value: client.id, className: css(styles.checkbox) }, client.displayName)))))))))) : (React.createElement(Menu.Item, { className: css(styles.item) },
            React.createElement("div", null, "No client")))));
    return (React.createElement(Dropdown, { overlay: content, trigger: ['click'], placement: "bottomLeft", visible: visible, onVisibleChange: handleVisibleChange },
        React.createElement(Badge, { count: count, style: { background: '#2a90fe' } },
            React.createElement("div", { className: css(styles.flex, styles.m5) },
                React.createElement("div", { className: css(styles.capitalize) }, title),
                React.createElement(CaretDownOutlined, { className: css(styles.m4) })))));
};export{ClientDropdown};//# sourceMappingURL=ClientDropdown.js.map
