import*as React from'react';import {useState,useEffect}from'react';import {useSelector}from'react-redux';import {useFela}from'react-fela';import {Menu,Input,Checkbox,Dropdown,Badge}from'antd';import {DownOutlined,CaretDownOutlined}from'@ant-design/icons';import {useGetOrganizationClientsQuery,useGetProjectsQuery}from'@adminide-stack/account-api-client';import {styles}from'./styles.js';import {WITHOUT,FilterName}from'../ReportFilter.js';import*as _ from'lodash';var Status;
(function (Status) {
    Status["ACTIVE"] = "Active";
    Status["ARCHIVED"] = "Archived";
    Status["ACTIVE_ARCHIVED"] = "Active & Archived";
})(Status || (Status = {}));
const ProjectDropdown = (props) => {
    const { title, filteredData, setFilteredData } = props;
    const [visible, setVisible] = useState(false);
    const [show, setShow] = useState(false);
    const [checkedList, setCheckedList] = React.useState([]);
    const [checkAll, setCheckAll] = React.useState(false);
    const [status, setStatus] = useState(Status.ACTIVE);
    const [clientProjects, setClientProjects] = useState([]);
    const [filteredProjects, setFilteredProjects] = useState([]);
    const [count, setCount] = useState(0);
    const { css } = useFela();
    const orgName = useSelector((state) => state.platform.orgName);
    const { data: { getOrganizationClients: clients } = {}, refetch: refetchClients } = useGetOrganizationClientsQuery();
    const { data: { getProjects: projects } = {}, refetch } = useGetProjectsQuery();
    useEffect(() => {
        refetch();
        refetchClients();
    }, [orgName]);
    useEffect(() => {
        if (projects) {
            const projectList = _.chain(projects)
                .groupBy('clientId')
                .map((value, key) => ({ clientId: key, projects: value }))
                .value();
            setClientProjects(projectList);
            setFilteredProjects(projectList);
        }
    }, [projects]);
    useEffect(() => {
        setFilteredProjects(filterProjectsByStatus(status));
    }, [status]);
    const handleVisibleChange = (value) => {
        if (!value) {
            setFilteredData(Object.assign(Object.assign({}, filteredData), { [FilterName.PROJECT]: {
                    selectedIds: [...checkedList],
                } }));
            setCount(checkedList.length);
        }
        setVisible(value);
    };
    const showStatus = () => {
        setShow(!show);
    };
    const onClickStatus = ({ key }) => {
        setStatus(key);
        setShow(false);
        setCheckAll(false);
        setCheckedList([]);
    };
    const getProjectsId = () => {
        let ids = [];
        filteredProjects.forEach(({ projects }) => {
            projects.forEach((project) => {
                ids.push(project.id);
            });
        });
        return ids;
    };
    const onChange = list => {
        setCheckedList(list);
        setCheckAll(list.length === (getProjectsId().length + 1));
    };
    const onCheckAllChange = e => {
        let list = e.target.checked ? getProjectsId() : [];
        if (e.target.checked) {
            list.push(WITHOUT);
        }
        setCheckedList(list);
        setCheckAll(e.target.checked);
    };
    const onChangeInput = (e) => {
        let newProjects = [];
        if (e.target.value.trim()) {
            newProjects = filterProjectsByName(e.target.value);
        }
        else {
            newProjects = clientProjects;
        }
        setFilteredProjects(newProjects);
    };
    const filterProjectsByName = (str) => {
        const projectList = clientProjects === null || clientProjects === void 0 ? void 0 : clientProjects.map(({ clientId, projects }) => {
            return ({
                clientId,
                projects: projects.filter((project) => {
                    return project.name.toLowerCase().includes(str.toLowerCase());
                }),
            });
        });
        return projectList.filter(({ projects }) => projects.length);
    };
    const filterProjectsByStatus = (status) => {
        const projectList = clientProjects === null || clientProjects === void 0 ? void 0 : clientProjects.map(({ clientId, projects }) => {
            return ({
                clientId,
                projects: projects.filter((project) => {
                    if (status === Status.ACTIVE_ARCHIVED) {
                        return (project.status === Status.ACTIVE || project.status === Status.ARCHIVED);
                    }
                    else {
                        return (project.status === status);
                    }
                }),
            });
        });
        return projectList.filter(({ projects }) => projects.length);
    };
    const getClientName = (id) => {
        const client = clients === null || clients === void 0 ? void 0 : clients.find((client) => client.id === id);
        return client === null || client === void 0 ? void 0 : client.displayName;
    };
    const content = (React.createElement(Menu, { className: css(styles.menu) },
        React.createElement(Menu.Item, { className: css(styles.item) },
            React.createElement(Input, { onChange: onChangeInput, placeholder: 'Find client...' })),
        React.createElement(Menu.Divider, { className: css(styles.divider) }),
        React.createElement(Menu.Item, { className: css(styles.item) },
            React.createElement("div", { style: { display: 'flex' } },
                React.createElement("div", { className: css(styles.label) }, "SHOW"),
                React.createElement("div", { style: { marginLeft: 'auto' }, onClick: showStatus },
                    React.createElement("a", null, status),
                    React.createElement(DownOutlined, { className: css(styles.icon) })))),
        React.createElement(Menu.Divider, { className: css(styles.divider) }),
        show ? (React.createElement(React.Fragment, null,
            React.createElement(Menu.Item, { className: css(styles.statusItem), key: Status.ACTIVE_ARCHIVED, onClick: onClickStatus },
                React.createElement("div", null, Status.ACTIVE_ARCHIVED)),
            React.createElement(Menu.Divider, { className: css(styles.divider) }),
            React.createElement(Menu.Item, { className: css(styles.statusItem), key: Status.ACTIVE, onClick: onClickStatus },
                React.createElement("div", null, Status.ACTIVE)),
            React.createElement(Menu.Divider, { className: css(styles.divider) }),
            React.createElement(Menu.Item, { className: css(styles.statusItem), key: Status.ARCHIVED, onClick: onClickStatus },
                React.createElement("div", null, Status.ARCHIVED)),
            React.createElement(Menu.Divider, { className: css(styles.divider) }))) : null,
        (filteredProjects.length || (clientProjects === null || clientProjects === void 0 ? void 0 : clientProjects.length)) ? (React.createElement(React.Fragment, null,
            React.createElement(Menu.Item, { className: css(styles.item) },
                React.createElement(Checkbox, { className: css(styles.checkbox), onChange: onCheckAllChange, checked: checkAll }, "Select all")),
            React.createElement(Menu.Divider, { className: css(styles.divider) }),
            React.createElement(Menu.Item, { className: css(styles.disabledItem) },
                React.createElement(Checkbox.Group, { className: css(styles.checkboxGroup), onChange: onChange, value: checkedList },
                    React.createElement(Menu, null,
                        React.createElement(Menu.Item, { key: WITHOUT, className: css(styles.item, styles.mTB0) },
                            React.createElement(Checkbox, { value: WITHOUT, className: css(styles.checkbox) }, 'Without project')), filteredProjects === null || filteredProjects === void 0 ? void 0 :
                        filteredProjects.map(({ projects, clientId }) => (React.createElement(React.Fragment, { key: clientId },
                            React.createElement(Menu.Divider, { className: css(styles.divider) }),
                            React.createElement(Menu.Item, { disabled: true, className: css(styles.item, styles.mTB0) },
                                React.createElement("div", { className: css(styles.label) }, getClientName(clientId))), projects === null || projects === void 0 ? void 0 :
                            projects.map((project) => (React.createElement(Menu.Item, { key: project.id, className: css(styles.item, styles.mTB0) },
                                React.createElement(Checkbox, { value: project.id, className: css(styles.checkbox) }, project.name)))))))))))) : (React.createElement(Menu.Item, { className: css(styles.item) },
            React.createElement("div", null, "No project")))));
    return (React.createElement(Dropdown, { overlay: content, trigger: ['click'], placement: "bottomLeft", visible: visible, onVisibleChange: handleVisibleChange },
        React.createElement(Badge, { count: count, style: { background: '#2a90fe' } },
            React.createElement("div", { className: css(styles.flex, styles.m5) },
                React.createElement("div", { className: css(styles.capitalize) }, title),
                React.createElement(CaretDownOutlined, { className: css(styles.m4) })))));
};export{ProjectDropdown};//# sourceMappingURL=ProjectDropdown.js.map
