import*as React from'react';import {useState}from'react';import {useFela}from'react-fela';import {Menu,Input,Checkbox,Dropdown,Badge}from'antd';import {DownOutlined,CaretDownOutlined}from'@ant-design/icons';import {WITHOUT,FilterName}from'../ReportFilter.js';import {styles}from'./styles.js';var Status;
(function (Status) {
    Status["ACTIVE"] = "Active";
    Status["COMPLETED"] = "Completed";
    Status["ACTIVE_COMPLETED"] = "Active & Completed";
})(Status || (Status = {}));
const TaskDropdown = (props) => {
    const { title, filteredData, setFilteredData } = props;
    const [visible, setVisible] = useState(false);
    const [show, setShow] = useState(false);
    const [checkedList, setCheckedList] = React.useState([]);
    const [checkAll, setCheckAll] = React.useState(false);
    const [status, setStatus] = useState(Status.ACTIVE);
    const [count, setCount] = useState(0);
    const { css } = useFela();
    const handleVisibleChange = (value) => {
        if (!value) {
            setCount(checkedList.length);
            setFilteredData(Object.assign(Object.assign({}, filteredData), { [FilterName.TASK]: {
                    selectedIds: [...checkedList]
                } }));
        }
        setVisible(value);
    };
    const showStatus = () => {
        setShow(!show);
    };
    const onClickStatus = ({ key }) => {
        setStatus(key);
        setShow(false);
    };
    const onChange = list => {
        setCheckedList(list);
        setCheckAll(list.length === 1);
    };
    const onCheckAllChange = e => {
        const list = e.target.checked ? [WITHOUT] : [];
        setCheckedList(list);
        setCheckAll(e.target.checked);
    };
    const onChangeInput = (e) => {
    };
    const content = (React.createElement(Menu, { className: css(styles.menu) },
        React.createElement(Menu.Item, { className: css(styles.item) },
            React.createElement(Input, { onChange: onChangeInput, placeholder: 'Find tasks...' })),
        React.createElement(Menu.Divider, { className: css(styles.divider) }),
        React.createElement(Menu.Item, { className: css(styles.item) },
            React.createElement("div", { style: { display: 'flex' } },
                React.createElement("div", { className: css(styles.label) }, "SHOW"),
                React.createElement("div", { style: { marginLeft: 'auto' }, onClick: showStatus },
                    React.createElement("a", null, status),
                    React.createElement(DownOutlined, { className: css(styles.icon) })))),
        React.createElement(Menu.Divider, { className: css(styles.divider) }),
        show ? (React.createElement(React.Fragment, null,
            React.createElement(Menu.Item, { className: css(styles.statusItem), key: Status.ACTIVE_COMPLETED, onClick: onClickStatus },
                React.createElement("div", null, Status.ACTIVE_COMPLETED)),
            React.createElement(Menu.Divider, { className: css(styles.divider) }),
            React.createElement(Menu.Item, { className: css(styles.statusItem), key: Status.ACTIVE, onClick: onClickStatus },
                React.createElement("div", null, Status.ACTIVE)),
            React.createElement(Menu.Divider, { className: css(styles.divider) }),
            React.createElement(Menu.Item, { className: css(styles.statusItem), key: Status.COMPLETED, onClick: onClickStatus },
                React.createElement("div", null, Status.COMPLETED)),
            React.createElement(Menu.Divider, { className: css(styles.divider) }))) : null,
        React.createElement(Menu.Item, { className: css(styles.item) },
            React.createElement(Checkbox, { className: css(styles.checkbox), onChange: onCheckAllChange, checked: checkAll }, "Select all")),
        React.createElement(Menu.Divider, { className: css(styles.divider) }),
        React.createElement(Menu.Item, { className: css(styles.disabledItem) },
            React.createElement(Checkbox.Group, { className: css(styles.checkboxGroup), onChange: onChange, value: checkedList },
                React.createElement(Menu, null,
                    React.createElement(Menu.Item, { key: WITHOUT, className: css(styles.item, styles.mTB0) },
                        React.createElement(Checkbox, { value: WITHOUT, className: css(styles.checkbox) }, 'Without task')))))));
    return (React.createElement(Dropdown, { overlay: content, trigger: ['click'], placement: "bottomLeft", visible: visible, onVisibleChange: handleVisibleChange },
        React.createElement(Badge, { count: count, style: { background: '#2a90fe' } },
            React.createElement("div", { className: css(styles.flex, styles.m5) },
                React.createElement("div", { className: css(styles.capitalize) }, title),
                React.createElement(CaretDownOutlined, { className: css(styles.m4) })))));
};export{TaskDropdown};//# sourceMappingURL=TaskDropdown.js.map
