import*as React from'react';import {useState}from'react';import {useFela}from'react-fela';import {Menu,Checkbox,Card,Dropdown,Divider,Button}from'antd';import {CaretDownOutlined}from'@ant-design/icons';import {ClientDropdown}from'./FilterDropdown/ClientDropdown.js';import {MemberDropdown}from'./FilterDropdown/MemberDropdown.js';import {ProjectDropdown}from'./FilterDropdown/ProjectDropdown.js';import {StatusDropdown,Status}from'./FilterDropdown/StatusDropdown.js';import {DescriptionDropdown}from'./FilterDropdown/DescriptionDropdown.js';import {TaskDropdown}from'./FilterDropdown/TaskDropdown.js';import {TagDropdown}from'./FilterDropdown/TagDropdown.js';import*as _ from'lodash';var FilterName;
(function (FilterName) {
    FilterName["MEMBER"] = "member";
    FilterName["CLIENT"] = "client";
    FilterName["PROJECT"] = "project";
    FilterName["TASK"] = "task";
    FilterName["TAG"] = "tag";
    FilterName["STATUS"] = "status";
    FilterName["DESCRIPTION"] = "description";
})(FilterName || (FilterName = {}));
const WITHOUT = 'without';
const FilterTypes = [
    { value: FilterName.MEMBER, selected: true, dropdown: (props) => React.createElement(MemberDropdown, Object.assign({}, props)) },
    { value: FilterName.CLIENT, selected: true, dropdown: (props) => React.createElement(ClientDropdown, Object.assign({}, props)) },
    { value: FilterName.PROJECT, selected: true, dropdown: (props) => React.createElement(ProjectDropdown, Object.assign({}, props)) },
    { value: FilterName.TASK, selected: true, dropdown: (props) => React.createElement(TaskDropdown, Object.assign({}, props)) },
    { value: FilterName.TAG, selected: true, dropdown: (props) => React.createElement(TagDropdown, Object.assign({}, props)) },
    { value: FilterName.STATUS, selected: true, dropdown: (props) => React.createElement(StatusDropdown, Object.assign({}, props)) },
    { value: FilterName.DESCRIPTION, selected: true, dropdown: (props) => React.createElement(DescriptionDropdown, Object.assign({}, props)) },
];
const ReportFilter = (props) => {
    const { projects, records, setFilteredProjects, setFilteredRecords } = props;
    const [visible, setVisible] = useState(false);
    const [filterTypesItem, setFilterTypesItem] = useState(FilterTypes);
    const [filterTypes, setFilterTypes] = useState(FilterTypes);
    const [filteredData, setFilteredData] = useState({});
    const { css } = useFela();
    const onClickItem = ({ key }) => {
        const index = parseInt(key, 10);
        const updatedValue = Object.assign(Object.assign({}, filterTypes[index]), { selected: !filterTypes[index].selected });
        let valuesArray = filterTypes.slice(0);
        valuesArray.splice(index, 1, updatedValue);
        setFilterTypes(valuesArray);
    };
    const handleVisibleChange = (value) => {
        setVisible(value);
        if (!value) {
            setFilterTypesItem(filterTypes);
        }
    };
    const filterRecordsByProject = (filteredProjects, newRecords, isWithoutProject) => {
        const projectIds = filteredProjects.map((project) => project.id);
        return newRecords.filter((record) => {
            if (isWithoutProject) {
                return (projectIds.includes(record.projectId) || !record.projectId);
            }
            return projectIds.includes(record.projectId);
        });
    };
    const filterProjectsByRecord = (filteredRecords, newProjects) => {
        const projectIds = filteredRecords.map(record => record.projectId);
        return newProjects.filter(project => projectIds.includes(project.id));
    };
    const clientFilter = (newProjects, newRecords, clientIds) => {
        let filteredProjects = newProjects.slice(0);
        if (clientIds.length) {
            filteredProjects = newProjects.filter((project) => {
                if (clientIds.includes(WITHOUT)) {
                    return (clientIds.includes(project.clientId) || !project.clientId);
                }
                return clientIds.includes(project.clientId);
            });
            return ({
                projects: filteredProjects,
                records: filterRecordsByProject(filteredProjects, newRecords, true),
            });
        }
        return ({ projects: newProjects, records: newRecords });
    };
    const projectFilter = (newProjects, newRecords, projectIds) => {
        let filteredProjects = newProjects.slice(0);
        if (projectIds.length) {
            filteredProjects = newProjects.filter((project) => {
                if (projectIds.includes(WITHOUT)) {
                    return (projectIds.includes(project.id) || !project.id);
                }
                return projectIds.includes(project.id);
            });
            return ({
                projects: filteredProjects,
                records: filterRecordsByProject(filteredProjects, newRecords, projectIds.includes(WITHOUT)),
            });
        }
        return ({ projects: newProjects, records: newRecords });
    };
    const descriptionFilter = (newProjects, newRecords, input, isWithout) => {
        let filteredRecords = newRecords.slice(0);
        if (input.trim() || isWithout) {
            filteredRecords = newRecords.filter((record) => {
                var _a, _b;
                if (input.trim() && isWithout) {
                    return (((_a = record.description) === null || _a === void 0 ? void 0 : _a.includes(input)) || !record.description);
                }
                else if (input.trim() && !isWithout) {
                    return (_b = record.description) === null || _b === void 0 ? void 0 : _b.includes(input);
                }
                else {
                    return !record.description;
                }
            });
            return ({
                projects: filterProjectsByRecord(filteredRecords, newProjects),
                records: filteredRecords,
            });
        }
        return ({ projects: newProjects, records: newRecords });
    };
    const memberFilter = (newProjects, newRecords, userIds) => {
        let filteredRecords = newRecords.slice(0);
        if (userIds.length) {
            filteredRecords = newRecords.filter((record) => userIds.includes(record.userId));
            return ({
                projects: filterProjectsByRecord(filteredRecords, newProjects),
                records: filteredRecords,
            });
        }
        return ({ projects: newProjects, records: newRecords });
    };
    const taskFilter = (newProjects, newRecords, tasks) => {
        let filteredRecords = newRecords.slice(0);
        if (tasks.length) {
            filteredRecords = newRecords.filter((record) => {
                if (tasks.includes(WITHOUT)) {
                    return (tasks.includes(record.taskName) || !record.taskName);
                }
                return tasks.includes(record.taskName);
            });
            return ({
                projects: filterProjectsByRecord(filteredRecords, newProjects),
                records: filteredRecords,
            });
        }
        return ({ projects: newProjects, records: newRecords });
    };
    const tagFilter = (newProjects, newRecords, tags) => {
        let filteredRecords = newRecords.slice(0);
        if (tags.length) {
            filteredRecords = newRecords.filter((record) => {
                const diff = _.difference(record.tags || [], tags);
                if (tags.includes(WITHOUT)) {
                    return ((diff.length < ((record.tags || []).length)) || !record.tags.length);
                }
                return (diff.length < ((record.tags || []).length));
            });
            return ({
                projects: filterProjectsByRecord(filteredRecords, newProjects),
                records: filteredRecords,
            });
        }
        return ({ projects: newProjects, records: newRecords });
    };
    const statusFilter = (newProjects, newRecords, statuses) => {
        let filteredRecords = newRecords.slice(0);
        if (statuses.length) {
            filteredRecords = newRecords.filter((record) => {
                if (statuses.includes(Status.BILLABLE) && statuses.includes(Status.NON_BILLABLE)) {
                    return (record.isBillable || !record.isBillable);
                }
                else if (statuses.includes(Status.BILLABLE)) {
                    return record.isBillable;
                }
                else if (statuses.includes(Status.NON_BILLABLE)) {
                    return !record.isBillable;
                }
                return true;
            });
            return ({
                projects: filterProjectsByRecord(filteredRecords, newProjects),
                records: filteredRecords,
            });
        }
        return ({ projects: newProjects, records: newRecords });
    };
    const applyFilter = () => {
        let filteredProjects = projects.slice(0);
        let filteredRecords = records.slice(0);
        _.forIn(filteredData, (value, key) => {
            switch (key) {
                case FilterName.MEMBER:
                    const tData = memberFilter(filteredProjects, filteredRecords, filteredData[key].selectedIds);
                    filteredRecords = tData.records;
                    filteredProjects = tData.projects;
                    break;
                case FilterName.CLIENT:
                    const cData = clientFilter(filteredProjects, filteredRecords, filteredData[key].selectedIds);
                    filteredRecords = cData.records;
                    filteredProjects = cData.projects;
                    break;
                case FilterName.PROJECT:
                    const pData = projectFilter(filteredProjects, filteredRecords, filteredData[key].selectedIds);
                    filteredRecords = pData.records;
                    filteredProjects = pData.projects;
                    break;
                case FilterName.TASK:
                    const sData = taskFilter(filteredProjects, filteredRecords, filteredData[key].selectedIds);
                    filteredRecords = sData.records;
                    filteredProjects = sData.projects;
                    break;
                case FilterName.TAG:
                    const gData = tagFilter(filteredProjects, filteredRecords, filteredData[key].selectedIds);
                    filteredRecords = gData.records;
                    filteredProjects = gData.projects;
                    break;
                case FilterName.STATUS:
                    const uData = statusFilter(filteredProjects, filteredRecords, filteredData[key].selectedIds);
                    filteredRecords = uData.records;
                    filteredProjects = uData.projects;
                    break;
                case FilterName.DESCRIPTION:
                    const dData = descriptionFilter(filteredProjects, filteredRecords, filteredData[key].input, filteredData[key].isWithout);
                    filteredRecords = dData.records;
                    filteredProjects = dData.projects;
                    break;
            }
        });
        setFilteredProjects(filteredProjects);
        setFilteredRecords(filteredRecords);
    };
    const menu = (React.createElement(Menu, { className: css(styles.dropdown), onClick: onClickItem }, filterTypes.map((data, i) => (React.createElement(Menu.Item, { key: i },
        React.createElement(Checkbox, { className: css(styles.checkbox, styles.capitalize), checked: data.selected }, data.value))))));
    return (React.createElement(Card, { className: css(styles.card), bordered: false },
        React.createElement("div", { className: css(styles.flex) },
            React.createElement(Dropdown, { overlay: menu, trigger: ['click'], visible: visible, onVisibleChange: handleVisibleChange },
                React.createElement("div", { className: css(styles.m10, styles.flex) },
                    React.createElement("div", null, "Filter"),
                    React.createElement(CaretDownOutlined, { className: css(styles.m4) }))),
            React.createElement("div", { className: css(styles.menuWrapper) }, filterTypesItem.map((data, index) => {
                return (data.selected ? (React.createElement("div", { className: css(styles.flex), key: index },
                    React.createElement(Divider, { className: css(styles.divider), type: 'vertical' }),
                    React.createElement("div", { className: css(styles.m10) }, data.dropdown({ title: data.value, filteredData, setFilteredData })))) : null);
            })),
            React.createElement("div", { className: css(styles.buttonWrapper) },
                React.createElement(Button, { className: css(styles.button), size: 'large', type: 'primary', onClick: applyFilter }, "APPLY FILTER")))));
};
const styles = {
    card: () => ({
        width: '100%',
        overflowX: 'auto',
        marginBottom: '25px',
        '& .ant-card-body': {
            padding: '10px',
        },
    }),
    flex: () => ({
        display: 'flex',
    }),
    divider: () => ({
        height: '45px',
    }),
    m10: () => ({
        margin: '10px',
    }),
    m4: () => ({
        margin: '4px',
    }),
    button: () => ({
        marginRight: 0,
        marginLeft: 'auto',
        marginBottom: 'auto',
        marginTop: 'auto',
    }),
    dropdown: () => ({
        padding: '15px 0',
    }),
    checkbox: () => ({
        padding: '3px 10px',
        width: '100%',
    }),
    capitalize: () => ({
        textTransform: 'capitalize',
    }),
    menuWrapper: () => ({
        display: 'flex',
        width: '100%',
        overflow: 'auto',
        overflowY: 'hidden',
        '::-webkit-scrollbar': {
            height: '3px',
            background: '#ffffff',
        },
        '::-webkit-scrollbar-thumb': {
            background: '#c1c1c1',
            borderRadius: '10px',
            width: '2px',
        },
        '::-webkit-scrollbar-track': {
            background: '#ffffff',
        },
    }),
    buttonWrapper: () => ({
        marginLeft: 'auto',
        marginTop: 'auto',
        marginBottom: 'auto',
    }),
};export{FilterName,ReportFilter,WITHOUT};//# sourceMappingURL=ReportFilter.js.map
