import*as React from'react';import {useState,useEffect}from'react';import {useHistory,useParams,generatePath}from'react-router-dom';import {useFela}from'react-fela';import {Card}from'antd';import*as qs from'query-string';import moment from'moment';import'tslib';import {capitalize}from'../../utils/calculate.js';import {useGetTimesheetsQuery,useGetOrganizationMembersQuery}from'@admin-layout/timetracker-core/lib/generated/react-hooks';import {TimesheetTable}from'./TimesheetTable.js';import {ROUTES}from'../../timetracker/constants/routes.js';import'../../timetracker/constants/enums.js';import*as _ from'lodash';var VIEW_MODE;
(function (VIEW_MODE) {
    VIEW_MODE["ALL"] = "all";
    VIEW_MODE["OPENED"] = "opened";
    VIEW_MODE["SUBMITTED"] = "submitted";
    VIEW_MODE["APPROVED"] = "approved";
    VIEW_MODE["REJECTED"] = "rejected";
})(VIEW_MODE || (VIEW_MODE = {}));
var State;
(function (State) {
    State["OPEN"] = "OPEN";
    State["SUBMITTED"] = "SUBMITTED";
    State["APPROVED"] = "APPROVED";
    State["DENYED"] = "DENYED";
})(State || (State = {}));
const Timesheet = () => {
    const [tabKey, setTabKey] = useState(VIEW_MODE.OPENED);
    const [timesheetData, setTimesheetData] = useState([]);
    const [filteredTimesheet, setFilteredTimesheet] = useState([]);
    const history = useHistory();
    const { orgName } = useParams();
    const { css } = useFela();
    const { data, loading } = useGetTimesheetsQuery({
        variables: {
            withTotalHours: true,
        },
        fetchPolicy: 'no-cache',
    });
    const { data: membersData, loading: loadingMembers } = useGetOrganizationMembersQuery();
    useEffect(() => {
        var _a;
        if (data) {
            const tempData = (_a = data.getTimesheets) === null || _a === void 0 ? void 0 : _a.reverse().filter((timesheet) => {
                return moment().subtract(2, 'weeks') < moment(timesheet.startDate);
            });
            setTimesheetData(tempData);
        }
    }, [data]);
    useEffect(() => {
        let timeSheets = timesheetData.slice(0);
        switch (tabKey) {
            case VIEW_MODE.OPENED:
                timeSheets = timesheetData.filter((timesheet) => (timesheet.state === State.OPEN));
                break;
            case VIEW_MODE.SUBMITTED:
                timeSheets = timesheetData.filter((timesheet) => (timesheet.state === State.SUBMITTED));
                break;
            case VIEW_MODE.APPROVED:
                timeSheets = timesheetData.filter((timesheet) => (timesheet.state === State.APPROVED));
                break;
            case VIEW_MODE.REJECTED:
                timeSheets = timesheetData.filter((timesheet) => (timesheet.state === State.DENYED));
                break;
        }
        setFilteredTimesheet(timeSheets);
    }, [tabKey, timesheetData]);
    const onTabChange = (key) => {
        setTabKey(key);
    };
    const gotoTimesheetPage = () => {
        history.push({
            pathname: generatePath(ROUTES.Timesheet, { orgName }),
            search: qs.stringify({
                view: 'tabular',
                weekStart: moment().format('YYYY-MM-DD'),
                strict: 'true',
            }),
        });
    };
    const tabList = [
        { key: VIEW_MODE.OPENED, tab: capitalize(VIEW_MODE.OPENED) },
        { key: VIEW_MODE.SUBMITTED, tab: capitalize(VIEW_MODE.SUBMITTED) },
        { key: VIEW_MODE.APPROVED, tab: capitalize(VIEW_MODE.APPROVED) },
        { key: VIEW_MODE.REJECTED, tab: capitalize(VIEW_MODE.REJECTED) },
        { key: VIEW_MODE.ALL, tab: capitalize(VIEW_MODE.ALL) },
    ];
    if (loading || loadingMembers) {
        return null;
    }
    return (React.createElement(Card, { className: css(styles.card), title: 'Timesheet(Last 2 week status)', tabList: tabList, activeTabKey: tabKey, onTabChange: onTabChange },
        React.createElement(TimesheetTable, { timeSheets: filteredTimesheet, members: _.get(membersData, 'getOrganizationMembers', []) }),
        React.createElement("a", { onClick: gotoTimesheetPage }, "Check more...")));
};
const styles = {
    card: () => ({
        marginTop: '25px',
        '& .ant-tabs-tab': {
            fontSize: '15px !important',
        },
        '& .ant-table-row': {
            ':hover': {
                color: '#2b90fe !important',
            },
        },
    }),
    item: () => ({
        fontWeight: '500',
        marginRight: '10px',
    }),
};export{State,Timesheet};//# sourceMappingURL=Timesheet.js.map
