import*as React from'react';import {useState,useEffect}from'react';import {useHistory,useParams,generatePath}from'react-router-dom';import {Tag,Table}from'antd';import moment from'moment';import*as qs from'query-string';import {ROUTES}from'../../timetracker/constants/routes.js';import'../../timetracker/constants/enums.js';import {formatDuration}from'../../timetracker/services/timeRecordService.js';import {useTimeformat}from'../../timetracker/hooks/index.js';import {State}from'./Timesheet.js';const TimesheetTable = (props) => {
    const { members, timeSheets } = props;
    const [columns, setColumns] = useState([]);
    const history = useHistory();
    const { orgName } = useParams();
    const { dateFormat } = useTimeformat();
    useEffect(() => {
        setColumns([
            {
                title: 'User',
                dataIndex: 'userId',
                key: 'userId',
                render: (value) => {
                    const member = members.find((m) => m.userId === value);
                    return (React.createElement("div", null, member !== undefined ? member.name : ''));
                },
            },
            {
                title: 'Start Date',
                dataIndex: 'startDate',
                key: 'startDate',
                render: (value) => React.createElement("div", null, moment(value).format(dateFormat || 'YYYY-MM-DD')),
            },
            {
                title: 'End Date',
                dataIndex: 'endDate',
                key: 'endDate',
                render: (value) => React.createElement("div", null, moment(value).add(-1, 'day').format(dateFormat || 'YYYY-MM-DD')),
            },
            {
                title: 'Duration',
                dataIndex: 'totalDuration',
                key: 'totalDuration',
                render: (value) => React.createElement("div", null, formatDuration(value)),
            },
            {
                title: 'Submitted On',
                dataIndex: 'submittedOn',
                key: 'submittedOn',
                render: (value) => React.createElement("div", null, value ? moment(value).format(dateFormat || 'YYYY-MM-DD') : '-'),
            },
            {
                title: 'State',
                dataIndex: 'state',
                key: 'state',
                render: (value) => {
                    const color = {
                        [State.OPEN]: 'orange',
                        [State.APPROVED]: 'green',
                        [State.SUBMITTED]: 'blue',
                        [State.DENYED]: 'red',
                    };
                    return React.createElement(Tag, { color: color[value] }, value);
                },
            }
        ]);
    }, []);
    const onRow = (record, index) => {
        return {
            onClick: event => {
                history.push({
                    pathname: generatePath(ROUTES.Timesheet, { orgName }),
                    search: qs.stringify({
                        view: 'tabular',
                        weekStart: moment(record.startDate).format('YYYY-MM-DD'),
                        strict: 'true',
                    }),
                });
            },
        };
    };
    return (React.createElement(Table, { style: { width: '100%', overflowX: 'auto' }, rowKey: "id", columns: columns, dataSource: timeSheets, pagination: { defaultPageSize: 5 }, onRow: onRow }));
};export{TimesheetTable};//# sourceMappingURL=TimesheetTable.js.map
