import*as React from'react';import {useState,useEffect,useCallback,useMemo}from'react';import {useFela}from'react-fela';import {useSelector}from'react-redux';import {Card,Result}from'antd';import moment from'moment';import {usePermissionAutoFetch,useSetting}from'@adminide-stack/platform-client';import {useGetOrganizationMembersQuery,useGetUserAccountQuery}from'@adminide-stack/account-api-client';import {useViewPermissions,useSplitTimeRecordsPerDay,useFirstWeekDay}from'../timetracker/hooks/index.js';import {useGetDurationTimeRecordsQuery,useGetProjectsQuery}from'@admin-layout/timetracker-core/lib/generated/react-hooks';import {Reports}from'./ReportComponent.js';import {ReportFilter}from'./ReportFilter.js';import {IPreDefineAccountPermissions}from'../timetracker/constants/enums.js';import*as _ from'lodash';const GetDurationTimeRecordsByUserIdQuery = ({ range, userId, recordsByUserId, setRecordsByUserId }) => {
    const [records, setRecords] = useState({});
    const { data: { getDurationTimeRecords } = {}, loading, refetch } = useGetDurationTimeRecordsQuery({
        variables: {
            startTime: range.start,
            endTime: range.end,
            userId: userId,
        },
    });
    const timeRecords = useSplitTimeRecordsPerDay(getDurationTimeRecords);
    const { data: { getUserAccount } = {} } = useGetUserAccountQuery({
        variables: { userId },
        skip: !userId,
    });
    const { data: billRateConfig } = useSetting({
        configKey: 'timetracker.user.payment.billRate',
        overrides: { overrideIdentifier: getUserAccount === null || getUserAccount === void 0 ? void 0 : getUserAccount.username },
    });
    const { data: payRateConfig } = useSetting({
        configKey: 'timetracker.user.payment.payRate',
        overrides: { overrideIdentifier: getUserAccount === null || getUserAccount === void 0 ? void 0 : getUserAccount.username },
    });
    const billRate = billRateConfig === null || billRateConfig === void 0 ? void 0 : billRateConfig.resolveConfiguration;
    const payRate = payRateConfig === null || payRateConfig === void 0 ? void 0 : payRateConfig.resolveConfiguration;
    useEffect(() => {
        refetch();
    }, [range, userId]);
    useEffect(() => {
        if (timeRecords && !loading) {
            setRecords({ data: timeRecords });
        }
    }, [timeRecords, userId, range, loading]);
    useEffect(() => {
        if (records === null || records === void 0 ? void 0 : records.data) {
            setRecords(Object.assign(Object.assign({}, records), { payRate, billRate }));
            setRecordsByUserId(Object.assign(Object.assign({}, recordsByUserId), { [userId]: Object.assign(Object.assign({}, records), { payRate, billRate }) }));
        }
    }, [payRate, billRate, records === null || records === void 0 ? void 0 : records.data]);
    return null;
};
const Report = () => {
    const { data: selfData, loading: loadingSelf } = usePermissionAutoFetch({
        configKey: IPreDefineAccountPermissions.viewSelfTimeTracker,
    });
    const { data: othersData, loading: loadingOthers } = usePermissionAutoFetch({
        configKey: IPreDefineAccountPermissions.manageOthersTimeTracker,
    });
    const userId = useSelector((state) => state.user.auth0UserId);
    const orgName = useSelector((state) => state.platform.orgName);
    const [viewSelfPermit, setViewSelfPermit] = useState('');
    const [manageOthersPermit, setManageOthersPermit] = useState('');
    const [recordsByUserId, setRecordsByUserId] = useState({});
    const [records, setRecords] = useState([]);
    const [filteredRecords, setFilteredRecords] = useState([]);
    const [projects, setProjects] = useState([]);
    const [filteredProjects, setFilteredProjects] = useState([]);
    const [range, setRange] = useState({ start: moment().startOf('week'), end: moment().endOf('week') });
    const { data: { getOrganizationMembers: orgMembers } = {}, refetch: refetchMember } = useGetOrganizationMembersQuery();
    const { data: { getDurationTimeRecords } = {}, loading, refetch } = useGetDurationTimeRecordsQuery({
        variables: {
            startTime: range.start,
            endTime: range.end,
        },
    });
    const timeRecords = useSplitTimeRecordsPerDay(getDurationTimeRecords);
    const { data: projectsData, loading: loadingProjects, refetch: refetchProject } = useGetProjectsQuery();
    const { updateConfiguration } = useSetting({
        configKey: 'timetracker.report.timeRoundingInReports',
    });
    const { value: dowValue } = useFirstWeekDay();
    useEffect(() => {
        setRange({
            start: moment().startOf('week'),
            end: moment().endOf('week'),
        });
    }, []);
    useEffect(() => {
        refetch();
        refetchMember();
        refetchProject();
    }, [orgName]);
    useEffect(() => {
        refetch();
    }, [range]);
    useEffect(() => {
        moment.locale('en', {
            week: { dow: dowValue },
        });
        setRange({
            start: moment().startOf('week'),
            end: moment().endOf('week'),
        });
    }, [dowValue]);
    const getRecords = useCallback(() => (loading || !!!timeRecords ? [] : timeRecords), [loading, timeRecords]);
    const getProjects = useCallback(() => (loadingProjects || !!!projectsData ? [] : projectsData.getProjects), [loadingProjects, projectsData]);
    useEffect(() => {
        if ((orgMembers === null || orgMembers === void 0 ? void 0 : orgMembers.length) && timeRecords) {
            const users = orgMembers.filter((user) => {
                if (manageOthersPermit === "Allow" /* Allow */ && user.userId !== userId)
                    return true;
                if (viewSelfPermit === "Allow" /* Allow */ && user.userId === userId)
                    return true;
                return false;
            });
            const userIds = users.map((user) => user.userId);
            const authUsersRecords = getRecords().filter((record) => userIds.includes(record.userId));
            setRecords(authUsersRecords);
            setFilteredRecords(authUsersRecords);
        }
    }, [timeRecords, orgMembers, viewSelfPermit, manageOthersPermit]);
    useEffect(() => {
        if (projectsData) {
            setProjects(getProjects());
            setFilteredProjects(getProjects());
        }
    }, [projectsData]);
    useEffect(() => {
        setViewSelfPermit(_.get(selfData, 'resolveConfiguration', "NotSet" /* NotSet */));
    }, [selfData, loadingSelf]);
    useEffect(() => {
        setManageOthersPermit(_.get(othersData, 'resolveConfiguration', "NotSet" /* NotSet */));
    }, [othersData, loadingOthers]);
    return useMemo(() => (React.createElement(React.Fragment, null, orgMembers === null || orgMembers === void 0 ? void 0 :
        orgMembers.map((member, index) => {
            return (React.createElement(GetDurationTimeRecordsByUserIdQuery, { key: index, range: range, userId: member.userId, recordsByUserId: recordsByUserId, setRecordsByUserId: setRecordsByUserId }));
        }),
        React.createElement(ReportFilter, { projects: projects, setFilteredProjects: setFilteredProjects, records: records, setFilteredRecords: setFilteredRecords }),
        React.createElement(Reports, { range: range, users: orgMembers, projects: filteredProjects, records: filteredRecords, setRange: setRange, updateConfiguration: updateConfiguration, recordsByUserId: recordsByUserId }))), [range, projects, filteredProjects, records, filteredRecords, recordsByUserId, orgMembers]);
};
const ReportWrapper = () => {
    const { self: viewSelfPermit } = useViewPermissions();
    const { css } = useFela();
    if (viewSelfPermit !== "Allow" /* Allow */) {
        return (React.createElement(Card, { className: css(styles.container) },
            React.createElement(Result, { status: 'info', title: 'Permission Denied' })));
    }
    return React.createElement(Report, null);
};
const styles = {
    container: () => ({
        '& .ant-result': {
            padding: '20px 30px',
        },
        '& .ant-result-icon': {
            '> span': {
                color: '#c1c1c1 !important',
            },
        },
        '& .ant-result-title': {
            color: '#8c8c8c',
        }
    })
};export default ReportWrapper;//# sourceMappingURL=index.js.map
