import React__default,{useState,useEffect}from'react';import {formatDuration,stringToDuration,getSecsFromString}from'../../services/timeRecordService.js';import {Input}from'antd';/**
 * Convert input string to time formatted
 * @param dur
 * @returns string
 */
const formatDurationInput = (dur) => {
    const secs = getSecsFromString(dur);
    return formatDuration(secs);
};
function DurationInput(props) {
    const { duration, onChange, disabled } = props;
    const [inputStr, setInputStr] = useState('');
    useEffect(() => {
        if (duration === undefined)
            setInputStr('');
        else
            setInputStr(formatDuration(duration));
    }, [duration]);
    const handleChangeDuration = (event) => {
        setInputStr(event.target.value);
    };
    const onPressEnter = (event) => {
        if (event.target.value === '')
            setInputStr('');
        else
            setInputStr(formatDurationInput(event.target.value));
        onChange(stringToDuration(formatDurationInput(event.target.value)));
    };
    const onBlur = (event) => {
        const newDur = formatDurationInput(event.target.value);
        const originDur = formatDuration(duration);
        if (event.target.value === '' && duration === undefined)
            setInputStr('');
        else if (event.target.value === '' && duration !== undefined) {
            // need to submit change
            setInputStr(formatDurationInput(event.target.value));
            onChange(stringToDuration(formatDurationInput(event.target.value)));
        }
        else {
            if (newDur === originDur) {
                // no need to submit change
                setInputStr(formatDurationInput(event.target.value));
            }
            else {
                // need to submit change
                setInputStr(formatDurationInput(event.target.value));
                onChange(stringToDuration(formatDurationInput(event.target.value)));
            }
        }
    };
    return (React__default.createElement(Input, { onChange: handleChangeDuration, value: inputStr, onPressEnter: onPressEnter, onBlur: onBlur, disabled: disabled }));
}export default DurationInput;//# sourceMappingURL=index.js.map
