import React__default,{useState,useEffect}from'react';import {MinusOutlined,CloseOutlined,PauseOutlined,CaretRightFilled,StopFilled,DownOutlined,UpOutlined}from'@ant-design/icons';import {useGetTasksLazyQuery}from'@adminide-stack/account-api-client';import {Button,Select,Typography}from'antd';import {useFela}from'react-fela';import {styleSheet}from'./style.js';import {TimerComponent}from'../../../TimeTracker/TimerComponent.js';import {useGetProjectsLazyQuery}from'@admin-layout/timetracker-core/lib/generated/react-hooks';import {uniqBy}from'lodash';const WidgetMaximized = (props) => {
    const { css } = useFela();
    const { Text } = Typography;
    const { Option } = Select;
    const { onClose, onStart, onMinimize, trackStarted, hidden, currentTimeRecord, updatePlayingTimeRecord, onPause, isPause, onStop, isDraggable, startLoading, stopLoading } = props;
    const [expanded, setExpanded] = useState(true);
    const [projects, setProjects] = useState([]);
    const [tasks, setTasks] = useState([]);
    const [loadProjects, { called: pCalled, data: projectsData }] = useGetProjectsLazyQuery();
    const [loadTasks, { called: tCalled, data: taskData }] = useGetTasksLazyQuery();
    useEffect(() => {
        if (projectsData) {
            setProjects(projectsData.getProjects);
        }
    }, [projectsData]);
    useEffect(() => {
        if (taskData) {
            setTasks(taskData.getTasks);
        }
    }, [taskData]);
    useEffect(() => {
        if (currentTimeRecord.projectId && !pCalled) {
            loadProjects();
        }
    }, [currentTimeRecord.projectId]);
    useEffect(() => {
        if (currentTimeRecord.taskName && !tCalled) {
            loadTasks();
        }
    }, [currentTimeRecord.taskName]);
    const handleSelect = (value, isProject) => {
        if (isProject) {
            updatePlayingTimeRecord(Object.assign(Object.assign({}, currentTimeRecord), { projectId: value, taskName: '' }));
        }
        else {
            updatePlayingTimeRecord(Object.assign(Object.assign({}, currentTimeRecord), { taskName: value }));
        }
    };
    const onDropdownVisible = (visible, isProject) => {
        if (visible && !pCalled && isProject) {
            loadProjects();
        }
        else if (visible && !tCalled && !isProject) {
            loadTasks();
        }
    };
    return (React__default.createElement("div", { hidden: hidden, className: css(styleSheet.container) },
        React__default.createElement("div", { className: css(styleSheet.headerTools) },
            React__default.createElement(Button, { shape: "circle", icon: React__default.createElement(MinusOutlined, null), size: "small", onClick: onMinimize, onTouchStart: isDraggable ? onMinimize : () => { }, style: { marginLeft: '30px', border: 'none' } }),
            React__default.createElement(Button, { shape: "circle", icon: React__default.createElement(CloseOutlined, null), size: "small", onClick: onClose, onTouchStart: isDraggable ? onClose : () => { }, style: { border: 'none' } })),
        React__default.createElement("div", { className: css(styleSheet.timerHandles) },
            React__default.createElement(Button, { type: "primary", shape: "circle", size: "large", icon: (!isPause && trackStarted) ? React__default.createElement(PauseOutlined, null) : React__default.createElement(CaretRightFilled, null), onClick: (!isPause && trackStarted) ? onPause : onStart, onTouchStart: isDraggable ? ((!isPause && trackStarted) ? onPause : onStart) : () => { }, style: { marginRight: '10px' }, loading: startLoading }),
            (trackStarted && (trackStarted || !startLoading)) ? (React__default.createElement(Button, { type: "primary", shape: "circle", size: "large", danger: true, icon: React__default.createElement(StopFilled, null), onClick: onStop, onTouchStart: isDraggable ? onStop : () => { }, style: { marginRight: '30px' }, loading: stopLoading })) : null,
            React__default.createElement(Text, { className: "timer-text" },
                React__default.createElement(TimerComponent, null))),
        React__default.createElement("div", { className: css(styleSheet.filters), hidden: !expanded },
            React__default.createElement(Select, { className: "select-project", placeholder: "Select a project", allowClear: true, value: currentTimeRecord.projectId || null, onChange: (value) => {
                    handleSelect(value, true);
                }, onDropdownVisibleChange: (visible) => {
                    onDropdownVisible(visible, true);
                } }, projects.map((project) => (React__default.createElement(Option, { key: project.id, value: project.id }, project.name)))),
            React__default.createElement(Select, { className: "select-to-do", placeholder: "Select a to do", allowClear: true, value: currentTimeRecord.taskName || null, onChange: (value) => {
                    handleSelect(value);
                }, onDropdownVisibleChange: (visible) => {
                    onDropdownVisible(visible);
                } }, uniqBy(tasks
                .filter((task) => task.projectId === currentTimeRecord.projectId), 'taskName')
                .map((task) => (React__default.createElement(Option, { key: task.id, value: task.taskName }, task.taskName))))),
        React__default.createElement("div", { className: css(styleSheet.expandToggle) },
            React__default.createElement(Button, { type: "default", shape: "circle", size: 'small', icon: !expanded ? React__default.createElement(DownOutlined, null) : React__default.createElement(UpOutlined, null), onClick: () => setExpanded(!expanded), onTouchStart: isDraggable ? () => setExpanded(!expanded) : () => { }, style: { border: 'none' } }))));
};export default WidgetMaximized;//# sourceMappingURL=index.js.map
