import React__default,{useState}from'react';import {useFela}from'react-fela';import {styleSheet}from'./style.js';import WidgetMinimized from'./WidgetMinimized/index.js';import WidgetMaximized from'./WidgetMaximized/index.js';var WidgetSize;
(function (WidgetSize) {
    WidgetSize["minimize"] = "minimize";
    WidgetSize["maximize"] = "maximize";
})(WidgetSize || (WidgetSize = {}));
const TimerWidget = (props) => {
    const { css } = useFela();
    const { onClose, onStart, trackStarted, currentTimeRecord, updatePlayingTimeRecord, onPause, onStop, isDraggable } = props;
    const [size, setSize] = useState(WidgetSize.maximize);
    const [startLoading, setStartLoading] = useState(false);
    const [stopLoading, setStopLoading] = useState(false);
    const minimize = () => {
        setSize(WidgetSize.minimize);
    };
    const maximize = () => {
        setSize(WidgetSize.maximize);
    };
    const onClickStart = () => {
        setStartLoading(true);
        onStart().then((res) => {
            setStartLoading(false);
        });
    };
    const onClickPause = () => {
        setStartLoading(true);
        onPause().then((res) => {
            setStartLoading(false);
        });
    };
    const onClickStop = () => {
        setStopLoading(true);
        onStop().then((res) => {
            setStopLoading(false);
        });
    };
    return (React__default.createElement("div", { className: css(styleSheet.TimerWidget) },
        React__default.createElement(WidgetMinimized, { trackStarted: trackStarted, isPause: currentTimeRecord.isPause, onClose: onClose, onStart: onClickStart, onPause: onClickPause, onStop: onClickStop, onMaximize: maximize, hidden: !(size === WidgetSize.minimize), isDraggable: isDraggable, startLoading: startLoading, stopLoading: stopLoading }),
        React__default.createElement(WidgetMaximized, { trackStarted: trackStarted, isPause: currentTimeRecord.isPause, currentTimeRecord: currentTimeRecord, updatePlayingTimeRecord: updatePlayingTimeRecord, onClose: onClose, onStart: onClickStart, onPause: onClickPause, onStop: onClickStop, onMinimize: minimize, hidden: !(size === WidgetSize.maximize), isDraggable: isDraggable, startLoading: startLoading, stopLoading: stopLoading })));
};export default TimerWidget;//# sourceMappingURL=index.js.map
