import*as React from'react';import {useState,useEffect}from'react';import {useFela}from'react-fela';import {Form,Modal,Button,Input,Switch,Tooltip,Avatar}from'antd';import {InfoCircleFilled,CheckOutlined,CloseOutlined}from'@ant-design/icons';const { Item } = Form;
const Days = ['Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday', 'Sunday'];
const LimitsModal = (props) => {
    const { visible, onClose, onSubmit, weeklyLimit, dailyLimit, daysAllowed } = props;
    const [isDailyLimit, setIsDailyLimit] = useState(!!dailyLimit);
    const [daysAllowedState, setDaysAllowedState] = useState(daysAllowed);
    const { css } = useFela();
    const [form] = Form.useForm();
    useEffect(() => {
        setDaysAllowedState(daysAllowed);
    }, [JSON.stringify(daysAllowed)]);
    useEffect(() => {
        setIsDailyLimit(!!dailyLimit);
    }, [dailyLimit]);
    useEffect(() => {
        if (!isDailyLimit) {
            form.setFields([{
                    name: 'dailyLimit',
                    value: '',
                    errors: [],
                }]);
        }
    }, [isDailyLimit]);
    const resetFields = () => {
        form.resetFields();
        setDaysAllowedState(daysAllowed);
        setIsDailyLimit(!!dailyLimit);
    };
    const onCloseModal = () => {
        onClose();
        resetFields();
    };
    const onFinish = (request) => {
        onSubmit(request, daysAllowedState, resetFields);
    };
    const onClickDay = (day) => {
        const tempDays = daysAllowedState.slice(0);
        if (tempDays.includes(day)) {
            const index = tempDays.indexOf(day);
            tempDays.splice(index, 1);
        }
        else {
            tempDays.push(day);
        }
        setDaysAllowedState(tempDays);
    };
    return (React.createElement(Modal, { visible: visible, title: "Limits", onCancel: onCloseModal, destroyOnClose: true, forceRender: true, footer: [
            React.createElement(Button, { key: 'back', onClick: onCloseModal }, "Cancel"),
            React.createElement(Button, { key: 'submit', type: 'primary', onClick: form.submit }, "Save"),
        ] },
        React.createElement(Form, { id: 'limits-form', form: form, className: css(styles.container), layout: 'vertical', onFinish: onFinish, initialValues: { weeklyLimit, dailyLimit } },
            React.createElement(Item, { label: 'Recurring Weekly Limit', rules: [{ required: true, message: 'Please enter weekly limit!' }], name: 'weeklyLimit', tooltip: { icon: React.createElement(InfoCircleFilled, null) } },
                React.createElement(Input, { addonAfter: 'hrs/wk', type: 'number', placeholder: 'No weekly limit' })),
            React.createElement(Item, { label: 'Recurring Daily Limit', tooltip: { icon: React.createElement(InfoCircleFilled, null) } },
                React.createElement("div", { className: css(styles.flex) },
                    React.createElement(Switch, { className: css(styles.mr10), checkedChildren: React.createElement(CheckOutlined, null), unCheckedChildren: React.createElement(CloseOutlined, null), checked: isDailyLimit, onChange: () => setIsDailyLimit(!isDailyLimit) }),
                    React.createElement("div", null, "Use shifts to set daily limits")),
                React.createElement(Item, { className: css(styles.mt15, styles.mb0), rules: [{ required: isDailyLimit, message: 'Please enter daily limit!' }], name: 'dailyLimit' },
                    React.createElement(Input, { addonAfter: 'hrs/day', type: 'number', disabled: !isDailyLimit, placeholder: 'No daily limit' }))),
            React.createElement(Item, { className: css(styles.mb0), label: 'Days Allowed To Work' },
                React.createElement("div", { className: css(styles.flex) }, Days.map((day, i) => {
                    const selectStyle = daysAllowedState.includes(day) ? styles.selectedColor : {};
                    return (React.createElement("div", { key: i, className: css(styles.mr10), onClick: () => onClickDay(day) },
                        React.createElement(Tooltip, { title: day },
                            React.createElement(Avatar, { size: 'large', className: css(selectStyle) }, day.slice(0, 3)))));
                }))))));
};
const styles = {
    container: () => ({
        '& .ant-form-item-label': {
            '> label': {
                color: '#6a6b6c',
                textTransform: 'uppercase',
                fontSize: '13px',
                fontWeight: '500',
            },
        },
    }),
    flex: () => ({
        display: 'flex',
    }),
    mr10: () => ({
        marginRight: '10px',
    }),
    mt15: () => ({
        marginTop: '15px',
    }),
    mb0: () => ({
        marginBottom: '0px',
    }),
    selectedColor: () => ({
        backgroundColor: '#1890ff',
    }),
};export{LimitsModal};//# sourceMappingURL=LimitsModal.js.map
