import*as React from'react';import {useFela}from'react-fela';import {Form,Modal,Button,Select,Switch,Input}from'antd';import {CheckOutlined,CloseOutlined}from'@ant-design/icons';const { Item } = Form;
const { Option } = Select;
var PayPeriod;
(function (PayPeriod) {
    PayPeriod["NONE"] = "None";
    PayPeriod["WEEKLY"] = "Weekly";
    PayPeriod["TWICE_PER_MONTH"] = "Twice per month";
    PayPeriod["BI_WEEKLY"] = "Bi-weekly";
    PayPeriod["MONTHLY"] = "Monthly";
})(PayPeriod || (PayPeriod = {}));
var PayRate;
(function (PayRate) {
    PayRate["HOURLY"] = "Hourly";
    PayRate["FIXED"] = "Fixed";
})(PayRate || (PayRate = {}));
const payPeriodOptions = ["None" /* NONE */, "Weekly" /* WEEKLY */, "Twice per month" /* TWICE_PER_MONTH */, "Bi-weekly" /* BI_WEEKLY */, "Monthly" /* MONTHLY */];
const payTypeOptions = ["Hourly" /* HOURLY */, "Fixed" /* FIXED */];
const PaymentsModal = (props) => {
    const { visible, onClose, payPeriod, payType, payRate, billRate, requireTimesheetApproval, onSubmit } = props;
    const { css } = useFela();
    const [form] = Form.useForm();
    const onCloseModal = () => {
        onClose();
        form.resetFields();
    };
    const onFinish = (request) => {
        onSubmit(request, form);
    };
    return (React.createElement(Modal, { visible: visible, title: "Payments", onCancel: onCloseModal, destroyOnClose: true, forceRender: true, footer: [
            React.createElement(Button, { key: 'back', onClick: onCloseModal }, "Cancel"),
            React.createElement(Button, { key: 'submit', type: 'primary', onClick: form.submit }, "Save"),
        ] },
        React.createElement(Form, { id: 'payment-form', form: form, className: css(styles.container), layout: 'vertical', onFinish: onFinish, initialValues: {
                payPeriod, payType, payRate, billRate, requireTimesheetApproval,
            } },
            React.createElement("div", { className: css(styles.flex) },
                React.createElement(Item, { className: css(styles.width50, styles.mr20), label: 'Pay Period', name: 'payPeriod' },
                    React.createElement(Select, { placeholder: 'Select pay period' }, payPeriodOptions.map((option, i) => (React.createElement(Option, { key: i, value: option }, option))))),
                React.createElement(Item, { className: css(styles.width50), label: 'Pay Type', name: 'payType' },
                    React.createElement(Select, { placeholder: 'Select pay type' }, payTypeOptions.map((option, i) => (React.createElement(Option, { key: i, value: option }, option)))))),
            React.createElement(Item, null,
                React.createElement("div", { className: css(styles.flex) },
                    React.createElement(Item, { noStyle: true, name: 'requireTimesheetApproval', valuePropName: 'checked' },
                        React.createElement(Switch, { checkedChildren: React.createElement(CheckOutlined, null), unCheckedChildren: React.createElement(CloseOutlined, null) })),
                    React.createElement("div", { className: css(styles.timesheet) }, "Require timesheet approval"))),
            React.createElement("div", { className: css(styles.flex) },
                React.createElement(Item, { className: css(styles.width50, styles.mr20), rules: [{ required: true, message: 'Please enter pay rate!' }], label: 'Pay Rate', name: 'payRate' },
                    React.createElement(Input, { type: 'number', addonAfter: 'USD/hr' })),
                React.createElement(Item, { className: css(styles.width50), rules: [{ required: true, message: 'Please enter bill rate!' }], label: 'Bill Rate', name: 'billRate' },
                    React.createElement(Input, { type: 'number', addonAfter: 'USD/hr' }))))));
};
const styles = {
    container: () => ({
        '& .ant-form-item-label': {
            '> label': {
                color: '#6a6b6c',
                textTransform: 'uppercase',
                fontSize: '13px',
                fontWeight: '500',
            },
        },
    }),
    flex: () => ({
        display: 'flex',
    }),
    width50: () => ({
        width: '50%',
    }),
    mr20: () => ({
        marginRight: '20px',
    }),
    timesheet: () => ({
        color: '#828588',
        margin: '0px 10px',
    }),
};export{PaymentsModal};//# sourceMappingURL=PaymentsModal.js.map
