import React__default,{useState,useEffect}from'react';import {useFela}from'react-fela';import {Form,Modal,Button,Input,Dropdown,Menu,Row,Col,Select}from'antd';import {uniqBy}from'lodash';const ProjectDropdown = ({ projects, tasks, handleSelectProjectTask, createTask, children, selectedProjectId, selectedTask, }) => {
    const { css } = useFela();
    const [showCreateModal, setShowCreateModal] = useState(false);
    const [visibleOverlay, setVisibleOverlay] = useState(false);
    const [selProjectId, setSelProjectId] = useState(null);
    const [selTask, setSelTask] = useState({});
    const [form] = Form.useForm();
    useEffect(() => {
        setSelProjectId(selectedProjectId);
    }, [selectedProjectId]);
    useEffect(() => {
        setSelTask(selectedTask && selectedProjectId ? { [selectedProjectId]: selectedTask } : {});
    }, [selectedTask]);
    const handleClickCreateTask = (projectId) => {
        setSelProjectId(projectId);
        // setVisibleOverlay(false);
        setShowCreateModal(true);
    };
    const handleSubmitTask = () => {
        if (form.validateFields()) {
            console.log(form.getFieldsValue());
            createTask(Object.assign(Object.assign({}, form.getFieldsValue()), { projectId: selProjectId })).then(() => {
                setShowCreateModal(false);
                setVisibleOverlay(true);
                onSelectTask(form.getFieldsValue().taskName, selProjectId);
                form.resetFields();
            });
        }
    };
    const handleVisibleChange = (flag) => {
        setVisibleOverlay(flag);
    };
    const onSelectTask = (task, projectId) => {
        setSelTask(Object.assign(Object.assign({}, selTask), { [projectId]: task }));
        handleSelectProjectTask(projectId, task);
    };
    const onClickItem = ({ key }) => {
        handleSelectProjectTask(key, selTask[key] || '');
    };
    const onCloseModal = () => {
        setShowCreateModal(false);
        form.resetFields();
    };
    const overlay = () => (React__default.createElement(Menu, { defaultSelectedKeys: [selectedProjectId], selectedKeys: [selectedProjectId], className: css(styles.projectDown), onClick: onClickItem, selectable: true }, projects.map((project) => {
        return (React__default.createElement(Menu.Item, { key: project.id },
            React__default.createElement(Row, null,
                React__default.createElement(Col, { className: css(styles.projectName) }, project.name),
                React__default.createElement(Col, { className: css(styles.task) },
                    React__default.createElement(Button, { onClick: (event) => {
                            event.stopPropagation();
                            handleClickCreateTask(project.id);
                        } }, "Create Task"),
                    React__default.createElement(Select, { placeholder: "Select task", className: css(styles.taskSelect), onChange: (value) => { onSelectTask(value, project.id); }, onClick: (event) => event.stopPropagation(), value: selTask[project.id] || null }, uniqBy(tasks
                        .filter((task) => task.projectId === project.id), 'taskName')
                        .map((task) => (React__default.createElement(Select.Option, { value: task.taskName, key: task.id }, task.taskName))))))));
    })));
    return (React__default.createElement(React__default.Fragment, null,
        React__default.createElement(Modal, { title: "Create a new task", visible: showCreateModal, onCancel: onCloseModal, className: css(styles.modal), footer: [
                React__default.createElement(Button, { key: "submit", type: "primary", onClick: handleSubmitTask }, "Submit"),
            ] },
            React__default.createElement(Form, { form: form },
                React__default.createElement(Form.Item, { label: "Task Name", name: "taskName", rules: [{ required: true, message: 'Please input your task!' }] },
                    React__default.createElement(Input, null)))),
        React__default.createElement(Dropdown, { overlay: overlay, trigger: ['click'], visible: visibleOverlay, onVisibleChange: handleVisibleChange }, children)));
};
const styles = {
    projectDown: ({ theme }) => ({
        display: 'block',
        '& .selected': {
            fontStyle: 'bold',
            color: 'red',
        },
    }),
    projectName: () => ({
        marginTop: 'auto',
        marginBottom: 'auto',
        marginRight: '10px',
    }),
    task: () => ({
        marginLeft: 'auto',
    }),
    taskSelect: () => ({
        width: '120',
    }),
};export{ProjectDropdown};//# sourceMappingURL=ProjectDropdown.js.map
