import React__default,{useState,useEffect}from'react';import {Modal,Form,Divider,Row,Col,Input,Select,Switch,Alert,Button,TimePicker}from'antd';import {calculateTimeDurationSec}from'@admin-layout/timetracker-core';import moment from'moment';import {useFela}from'react-fela';import*as _ from'lodash';import DurationInput from'../DurationInput/index.js';const { RangePicker } = TimePicker;
function TimesheetEditModal({ show, records, handleOk, handleClose, handleSaveRecord, projectTitle, }) {
    const [startTime, setStartTime] = useState(moment());
    const [endTime, setEndTime] = useState(moment());
    const [pauseStatus, setPauseStatus] = useState([]);
    const [duration, setDuration] = useState(0);
    const [taskName, setTaskName] = useState('');
    const [isBillable, setIsBillable] = useState(false);
    const { css } = useFela();
    useEffect(() => {
        setStartTime(records[0].startTime);
        setEndTime(records[0].endTime);
        setPauseStatus(records[0].pauseStatus);
        setDuration(totalDuration());
        setTaskName(records[0].taskName);
        setIsBillable(records[0].isBillable);
    }, [records]);
    useEffect(() => {
        setDuration(Math.abs(calculateTimeDurationSec(startTime, endTime, pauseStatus)));
    }, [startTime, endTime, pauseStatus]);
    const renderDateString = () => {
        if (records.length > 0)
            return moment(records[0].startTime).format('YYYY-MM-DD');
    };
    const totalDuration = () => {
        let totalDur = 0;
        records.forEach(r => {
            const dur = calculateTimeDurationSec(r.startTime, r.endTime, r.pauseStatus);
            totalDur = totalDur + Math.abs(dur);
        });
        return totalDur;
    };
    const handleChangeRange = (ranges, str) => {
        const rangeStart = ranges[0];
        const rangeEnd = ranges[1];
        setStartTime(rangeStart);
        setEndTime(rangeEnd);
    };
    const handleSave = () => {
        let range = {};
        if (!records[0].isSplit) {
            range = { startTime, endTime };
        }
        const updateRequest = Object.assign(Object.assign(Object.assign({}, _.omit(records[0], ['__typename', 'id', 'isEndDay', 'isSplit', 'startTime', 'endTime'])), range), { isBillable,
            taskName, pauseStatus: records[0].pauseStatus.map(({ pausedTime, restartTime }) => ({ pausedTime, restartTime })) });
        handleSaveRecord(records[0].id, updateRequest);
    };
    const handleChangeDuration = duration => {
        setEndTime(moment(startTime).add(duration, 'seconds'));
    };
    const handleChangeTaskName = event => {
        setTaskName(event.target.value);
    };
    const handleChangeBillable = checked => {
        setIsBillable(checked);
    };
    const renderDurationRange = () => {
        if (records.length === 1 && !records[0].isSplit) {
            return (React__default.createElement(Row, null,
                React__default.createElement(Col, null,
                    React__default.createElement(DurationInput, { duration: duration, onChange: handleChangeDuration })),
                React__default.createElement(Col, null,
                    React__default.createElement(RangePicker, { value: [moment(startTime), moment(endTime)], onChange: handleChangeRange, format: "HH:mm:ss", bordered: false }))));
        }
    };
    return (React__default.createElement(Modal, { title: "Edit Timesheet", visible: show, onCancel: handleClose, className: css(styles.modal), footer: false },
        React__default.createElement(Form, null,
            React__default.createElement("p", { className: "date" },
                " ",
                renderDateString(),
                " "),
            React__default.createElement("h3", { className: "project-name" },
                " ",
                projectTitle),
            React__default.createElement(Divider, null),
            renderDurationRange(),
            React__default.createElement(Divider, null),
            React__default.createElement(Row, { className: "form-row" },
                React__default.createElement(Col, { sm: 6 }, " Description: "),
                React__default.createElement(Col, { sm: 18 },
                    React__default.createElement(Input, { value: taskName, onChange: handleChangeTaskName }))),
            React__default.createElement(Row, { className: "form-row" },
                React__default.createElement(Col, { sm: 6 }, " Tags: "),
                React__default.createElement(Col, { sm: 18 },
                    React__default.createElement(Select, { mode: "tags", style: { width: '100%' } }))),
            React__default.createElement(Row, { className: "form-row" },
                React__default.createElement(Col, { sm: 6 }, "Billable"),
                React__default.createElement(Col, { sm: 18 }, records.length === 1 ? (React__default.createElement(Switch, { checked: isBillable, onChange: handleChangeBillable })) : (React__default.createElement(Alert, { type: "warning", message: "Not Available" })))),
            React__default.createElement(Divider, null),
            React__default.createElement(Row, { className: "footer" },
                React__default.createElement(Button, { type: "primary", onClick: handleSave }, "Save"),
                React__default.createElement("div", { className: "spacer" }, " "),
                React__default.createElement(Button, { onClick: handleClose }, "Cancel")))));
}
const styles = {
    timesheet: theme => ({
        display: 'flex',
        flexDirection: 'row',
    }),
    modal: theme => ({
        display: 'block',
        '& .date': {
            color: '#eee',
        },
        '& .form-row': {
            marginTop: '10px',
        },
        '& .footer': {
            display: 'flex',
            flexDirection: 'row',
            '& .spacer': {
                flexGrow: '1',
            },
        },
    }),
};export default TimesheetEditModal;//# sourceMappingURL=TimesheetEditModal.js.map
