import React__default,{useState}from'react';import {useFela}from'react-fela';import {Button}from'antd';import {MoreOutlined}from'@ant-design/icons';import moment from'moment';import {calculateTimeDurationSec}from'@admin-layout/timetracker-core';import*as _ from'lodash';import DurationInput from'../DurationInput/index.js';import TimesheetEditModal from'./TimesheetEditModal.js';const TimesheetInput = (props) => {
    const { dateStr, records, projectId, userId, createTimeRecord, updateTimeRecord, projectTitle, disabled } = props;
    const { css } = useFela();
    const [isModalVisible, setIsModalVisible] = useState(false);
    const handleMore = (event) => {
        event.preventDefault();
        setIsModalVisible(true);
    };
    const totalDuration = () => {
        return records.reduce((totalDur, r) => {
            const dur = calculateTimeDurationSec(r.startTime, r.endTime, r.pauseStatus);
            return (totalDur + Math.abs(dur));
        }, 0);
    };
    const handleChangeDuration = (dur) => {
        if (records === undefined || records.length === 0) {
            // empty
            const newRequest = {
                userId,
                startTime: moment(dateStr).add('9', 'hours'),
                endTime: moment(dateStr).add('9', 'hours').add(dur, 'seconds'),
                projectId: projectId,
            };
            createTimeRecord(newRequest);
        }
        else if (records.length === 1 && !records[0].isSplit) {
            const updatedEndTime = moment(records[0].startTime).add(dur, 'seconds');
            const updateRequest = Object.assign(Object.assign({}, _.omit(records[0], ['id', '__typename', 'isEndDay', 'isSplit'])), { endTime: updatedEndTime, pauseStatus: records[0].pauseStatus.map(({ pausedTime, restartTime }) => ({ pausedTime, restartTime })) });
            updateTimeRecord(records[0].id, updateRequest);
        }
    };
    const handleSaveRecord = (id, request) => {
        updateTimeRecord(id, request);
        setIsModalVisible(false);
    };
    return (React__default.createElement(React__default.Fragment, null,
        records && records.length >= 1 ? (React__default.createElement(TimesheetEditModal, { show: isModalVisible, records: records, handleClose: () => setIsModalVisible(false), handleOk: () => setIsModalVisible(false), handleSaveRecord: handleSaveRecord, projectTitle: projectTitle })) : null,
        React__default.createElement("div", { className: css(styles.timesheet) }, records && records.length > 0 ? (React__default.createElement(React__default.Fragment, null,
            React__default.createElement(DurationInput, { duration: totalDuration(), onChange: handleChangeDuration, disabled: disabled }),
            React__default.createElement(Button, { icon: React__default.createElement(MoreOutlined, null), onClick: handleMore, disabled: disabled }))) : (React__default.createElement(DurationInput, { onChange: handleChangeDuration, disabled: disabled })))));
};
const styles = {
    timesheet: (theme) => ({
        display: 'flex',
        flexDirection: 'row',
    }),
    modal: (theme) => ({
        display: 'block',
        '& .date': {
            color: '#eee',
        },
    }),
};export{TimesheetInput};//# sourceMappingURL=index.js.map
