import*as React from'react';import {IMenuPosition}from'@common-stack/client-react';import {FileOutlined}from'@ant-design/icons';import {WithPermissionEnhanced,WithPermissionBehaviour,WithPermission,ResourceSettings}from'@adminide-stack/platform-browser/lib/ant-module';import {IPreDefineAccountPermissions}from'@adminide-stack/core';import {getFilteredRoutes}from'../utils/menu.js';import TrayTimerHandler from'./components/TrayTimerHandler/index.js';import {ROUTES}from'./constants/routes.js';import'./constants/enums.js';const Home = React.lazy(() => import('./containers/Home.js'));
const TimeTracker = React.lazy(() => import('./containers/TimerPage/index.js'));
const Timesheet = React.lazy(() => import('./containers/TimesheetPage/index.js'));
const TimeApproval = React.lazy(() => import('./containers/TimeApprovalPage/index.js'));
const Reports = React.lazy(() => import('../DashboardReport/index.js'));
const OrganizationSettings = () => (React.createElement(WithPermissionEnhanced, { behaviour: WithPermissionBehaviour.showUnAuthorized, permissionKeys: [IPreDefineAccountPermissions.viewSettings] },
    React.createElement(WithPermission, { permissionKeys: [IPreDefineAccountPermissions.editSettings], render: ({ hasPermission }) => (React.createElement(ResourceSettings, { target: 4 /* ORGANIZATION */, showSidebar: true, hasPermission: hasPermission, options: { defaultFragment: "timeTracker" /* timeTracker */ } })) })));
const timePageStore = [
    {
        exact: false,
        icon: React.createElement(FileOutlined, null),
        key: 'timeTracker',
        auth: true,
        component: Home,
        position: IMenuPosition.MIDDLE,
        tab: 'Time Tracker',
        name: 'Time Tracker',
        path: ROUTES.TimeTracker,
        priority: 1,
    },
    {
        exact: true,
        key: 'timeTracker.timer',
        name: 'Timer',
        auth: true,
        component: TimeTracker,
        position: IMenuPosition.MIDDLE,
        path: ROUTES.Timer,
        priority: 2,
    },
    {
        exact: true,
        key: 'timeTracker.timer2',
        name: 'Timer2',
        auth: true,
        component: TrayTimerHandler,
        position: IMenuPosition.MIDDLE,
        path: ROUTES.Timer2,
        priority: 2,
    },
    {
        exact: true,
        key: 'timeTracker.timesheet',
        name: 'Timesheet',
        auth: true,
        component: Timesheet,
        position: IMenuPosition.MIDDLE,
        path: ROUTES.Timesheet,
        priority: 3,
    },
    {
        exact: true,
        key: 'timeTracker.timeapproval',
        name: 'Approvals',
        auth: true,
        component: TimeApproval,
        position: IMenuPosition.MIDDLE,
        path: ROUTES.TimeApproval,
        priority: 4,
    },
    {
        exact: true,
        key: 'timeTracker.report',
        name: 'Report',
        auth: true,
        component: Reports,
        position: IMenuPosition.MIDDLE,
        path: ROUTES.TimeReport,
        priority: 5,
    },
    {
        name: 'Settings',
        exact: true,
        key: 'timeTracker.settings',
        position: IMenuPosition.MIDDLE,
        path: ROUTES.Settings,
        hideInMenu: false,
        authority: [IPreDefineAccountPermissions.manageTeams],
        component: OrganizationSettings,
    },
];
const selectedRoutesAndMenus = [
    'timeTracker',
    'timeTracker.timer',
    'timeTracker.timer2',
    'timeTracker.projects',
    'timeTracker.clients',
    'timeTracker.timesheet',
    'timeTracker.timeapproval',
    'timeTracker.report',
    'timeTracker.settings',
];
// get routes
const filteredRoutes = getFilteredRoutes(timePageStore, selectedRoutesAndMenus);export{filteredRoutes,timePageStore};//# sourceMappingURL=compute.js.map
