import React__default,{useEffect}from'react';import {Spin,Tabs,message}from'antd';import {useGetTimesheetsQuery,useGetOrganizationMembersQuery,useUpdateTimesheetMutation}from'@admin-layout/timetracker-core/lib/generated/react-hooks';import*as _ from'lodash';import TimeReport from'./TimeReportTable.js';import {useViewPermissions}from'../../hooks/index.js';import {useSelector}from'react-redux';const { TabPane } = Tabs;
var VIEW_MODE;
(function (VIEW_MODE) {
    VIEW_MODE[VIEW_MODE["OPEN"] = 0] = "OPEN";
    VIEW_MODE[VIEW_MODE["SUBMITTED"] = 1] = "SUBMITTED";
    VIEW_MODE[VIEW_MODE["APPROVED"] = 2] = "APPROVED";
    VIEW_MODE[VIEW_MODE["DENYED"] = 3] = "DENYED";
    VIEW_MODE[VIEW_MODE["ALL"] = 4] = "ALL";
})(VIEW_MODE || (VIEW_MODE = {}));
const handleChangeTabView = (key) => {
    console.log(key);
};
const TimeReportWrapper = () => {
    const { data, loading, refetch } = useGetTimesheetsQuery({ variables: { withTotalHours: true } });
    const { data: membersData, loading: loadingMembers } = useGetOrganizationMembersQuery();
    const { others: viewOtherPermit, self: viewSelfPermit } = useViewPermissions();
    const [updateMutation, { loading: updateLoading }] = useUpdateTimesheetMutation();
    const userId = useSelector((state) => state.user.auth0UserId);
    useEffect(() => {
        refetch();
    }, []);
    const updateTimesheet = (sheetId, request) => {
        updateMutation({
            variables: { sheetId, request },
            update: (cache, { data, errors }) => {
                if (data) {
                    cache.modify({
                        fields: {
                            getTimesheets() { }
                        }
                    });
                    message.success('Timesheet updated');
                }
                else {
                    message.error(errors[0].message);
                }
            }
        });
    };
    const filteredMembers = () => {
        return _.get(membersData, 'getOrganizationMembers', []).filter((member) => {
            if (viewOtherPermit === "Allow" /* Allow */ && member.userId !== userId)
                return true;
            if (viewSelfPermit === "Allow" /* Allow */ && member.userId === userId)
                return true;
            return false;
        });
    };
    const filteredTimesheets = (state) => {
        const memStrArr = filteredMembers().map((mem) => mem.userId);
        return _.get(data, 'getTimesheets', []).filter((timesheet) => (timesheet.state === state || state === undefined) && memStrArr.includes(timesheet.userId));
    };
    return (React__default.createElement(Spin, { spinning: loading || updateLoading },
        React__default.createElement(Tabs, { defaultActiveKey: "1", onChange: handleChangeTabView },
            React__default.createElement(TabPane, { tab: "Opened", key: "1" },
                React__default.createElement(TimeReport, { timesheets: filteredTimesheets("OPEN" /* OPEN */), viewMode: VIEW_MODE.OPEN, members: _.get(membersData, 'getOrganizationMembers', []), updateTimesheet: updateTimesheet })),
            React__default.createElement(TabPane, { tab: "Submitted", key: "2" },
                React__default.createElement(TimeReport, { timesheets: filteredTimesheets("SUBMITTED" /* SUBMITTED */), viewMode: VIEW_MODE.SUBMITTED, members: _.get(membersData, 'getOrganizationMembers', []), updateTimesheet: updateTimesheet })),
            React__default.createElement(TabPane, { tab: "Approved", key: "3" },
                React__default.createElement(TimeReport, { timesheets: filteredTimesheets("APPROVED" /* APPROVED */), viewMode: VIEW_MODE.APPROVED, members: _.get(membersData, 'getOrganizationMembers', []), updateTimesheet: updateTimesheet })),
            React__default.createElement(TabPane, { tab: "Denied", key: "4" },
                React__default.createElement(TimeReport, { timesheets: filteredTimesheets("DENYED" /* DENYED */), viewMode: VIEW_MODE.DENYED, members: _.get(membersData, 'getOrganizationMembers', []), updateTimesheet: updateTimesheet })),
            React__default.createElement(TabPane, { tab: "All", key: "5" },
                React__default.createElement(TimeReport, { timesheets: filteredTimesheets(), viewMode: VIEW_MODE.ALL, members: _.get(membersData, 'getOrganizationMembers', []), updateTimesheet: updateTimesheet })))));
};export default TimeReportWrapper;export{VIEW_MODE};//# sourceMappingURL=index.js.map
