import React__default,{useState,useEffect}from'react';import {Calendar}from'react-big-calendar';import withDragAndDrop from'react-big-calendar/lib/addons/dragAndDrop';import moment from'moment';import {Row,Col,Button,Card,Tag}from'antd';import {PlusOutlined}from'@ant-design/icons';import TimesheetModal from'./TimesheetModal.js';import*as _ from'lodash';import'../../../constants/enums.js';import {EVENT_COLORS}from'../../../constants/colors.js';import {useFela}from'react-fela';const DnDCalendar = withDragAndDrop(Calendar);
const allViews = ['day', 'week', 'month'];
function SelectableCalendar({ userId, events, projects, members, isShowModal, loading, selectedEvent, handleAddTimeRecordEvent, handleUpdateTimeRecordEvent, handleRemoveTimeRecordEvent, handleCloseTimeModal, handleSelectSlot, handleSelectEvent, handleOpenNewTimeModal, localizer, weekStart, setPathWeekStart, }) {
    const [isApproved, setIsApproved] = useState(false);
    const { css } = useFela();
    useEffect(() => {
        let approved = false;
        events.forEach((t) => {
            approved = !!t.timesheetId || approved;
        });
        setIsApproved(approved);
    }, [events]);
    const onEventDrop = ({ event, start, end, allDay }) => {
        if (!event.isSplit) {
            const updateRequest = Object.assign(Object.assign({}, _.omit(event, ['id', '__typename', 'isEndDay', 'isSplit', 'title'])), { startTime: moment(start), endTime: moment(end) });
            handleUpdateTimeRecordEvent(event.id, updateRequest);
        }
    };
    const onEventResize = ({ event, start, end }) => {
        if (!event.isSplit) {
            const updateRequest = Object.assign(Object.assign({}, _.omit(event, ['id', '__typename', 'isEndDay', 'isSplit', 'title'])), { startTime: moment(start), endTime: moment(end) });
            handleUpdateTimeRecordEvent(event.id, updateRequest);
        }
    };
    const EventComponent = ({ event, start, end, title }) => {
        const project = projects.find((p) => p.id === event.projectId);
        return (React__default.createElement(React__default.Fragment, null,
            React__default.createElement("p", null,
                " ",
                project && project.name),
            React__default.createElement("p", null, title),
            React__default.createElement("p", null, start),
            React__default.createElement("p", null, end)));
    };
    const EventAgenda = ({ event }) => {
        return (React__default.createElement("span", null,
            React__default.createElement("em", { style: { color: 'magenta' } }, event.title),
            React__default.createElement("p", null, event.desc)));
    };
    const handleNavigate = (date) => {
        setPathWeekStart(moment(date));
    };
    const eventStyleGetter = (event) => {
        let memberNo = members.findIndex((m) => m.userId === event.userId);
        if (memberNo === -1)
            memberNo = 0;
        const color = EVENT_COLORS[memberNo];
        return {
            style: {
                color: color.main,
                backgroundColor: color.background,
                borderColor: color.background,
            },
        };
    };
    console.log('<<<Events----', events, weekStart);
    return (React__default.createElement(React__default.Fragment, null,
        React__default.createElement(TimesheetModal, { userId: userId, event: selectedEvent, isShowModal: isShowModal, members: members, projects: projects, loading: loading, handleAddTimeRecordEvent: handleAddTimeRecordEvent, handleUpdateTimeRecordEvent: handleUpdateTimeRecordEvent, handleRemoveTimeRecordEvent: handleRemoveTimeRecordEvent, handleCloseTimeModal: handleCloseTimeModal }),
        React__default.createElement(Row, { style: { marginBottom: '20px' } },
            React__default.createElement(Col, { xs: 24 },
                React__default.createElement(Button, { type: "primary", onClick: handleOpenNewTimeModal },
                    React__default.createElement(PlusOutlined, null),
                    " Add timesheet"))),
        React__default.createElement(Card, null,
            React__default.createElement(Row, null,
                React__default.createElement(Col, { xs: 24, md: 20 },
                    React__default.createElement("div", { className: css(stylesheet.styles) },
                        React__default.createElement(DnDCalendar, { selectable: true, localizer: localizer, events: events, defaultView: "week", views: allViews, defaultDate: moment(weekStart).toDate(), onSelectEvent: handleSelectEvent, onSelectSlot: handleSelectSlot, startAccessor: "startTime", endAccessor: "endTime", titleAccessor: "taskName", toolbar: true, resizable: !isApproved, draggableAccessor: event => !isApproved, onEventDrop: onEventDrop, onEventResize: onEventResize, components: {
                                event: EventComponent,
                                agenda: {
                                    event: EventAgenda,
                                },
                            }, onNavigate: handleNavigate, eventPropGetter: eventStyleGetter }))),
                React__default.createElement(Col, { xs: 24, md: 4, style: { marginTop: '20px', padding: '10px' } }, members.map((m, id) => (React__default.createElement(Tag, { key: id, color: EVENT_COLORS[id].background, style: { marginBottom: '5px' } },
                    React__default.createElement("span", { style: { color: EVENT_COLORS[id].main } },
                        " ",
                        m.name,
                        " ")))))))));
}
const stylesheet = {
    styles: (theme) => ({
        position: 'relative',
        width: '100%',
        // Default height for the Timesheet Calender view
        '& .rbc-calendar': {
            height: '100vh',
        },
        '& .sm-screen-size': {
            '@media (max-width: 768px)': {
                width: '100% !important',
            },
        },
        '& ul.jsx-4179805763': {
            zIndex: 1050,
            webkitBoxSizing: 'border-box',
            boxSizing: 'border-box',
            padding: '4px 0',
            fontSize: '13px',
            maxHeight: '100px',
            fontVariant: 'initial',
            backgroundColor: '#fff',
            borderRadius: '2px',
            outline: 'none',
            webkitBoxShadow: '0 3px 6px -4px rgba(0, 0, 0, 0.12), 0 6px 16px 0 rgba(0, 0, 0, 0.08), 0 9px 28px 8px rgba(0, 0, 0, 0.05)',
            boxShadow: '0 3px 6px -4px rgba(0, 0, 0, 0.12), 0 6px 16px 0 rgba(0, 0, 0, 0.08), 0 9px 28px 8px rgba(0, 0, 0, 0.05)',
        },
        '& div.jsx-4179805763': {
            marginTop: '8px',
            width: '100%',
        },
        '& .rbc-day-slot': {
            position: 'relative',
        },
        '& .rbc-day-slot .rbc-events-container': {
            bottom: 0,
            left: 0,
            position: 'absolute',
            right: 0,
            marginRight: '10px',
            top: 0,
        },
        '& .rbc-day-slot .rbc-events-container.rbc-rtl': {
            left: '10px',
            right: 0,
        },
        '& .rbc-day-slot .rbc-event': {
            border: '1px solid #265985',
            display: 'flex',
            maxHeight: '100%',
            minHeight: '20px',
            flexFlow: 'column wrap',
            alignItems: 'flex-start',
            overflow: 'hidden',
            position: 'absolute',
        },
        '& .rbc-event': {
            border: 'none',
            boxShadow: 'none',
            margin: 0,
            padding: '2px 5px',
            backgroundColor: '#3174ad',
            borderRadius: '5px',
            color: '#fff',
            cursor: 'pointer',
            width: '100%',
            textAlign: 'left',
        },
    }),
};export default SelectableCalendar;//# sourceMappingURL=Timesheet.js.map
