import*as React from'react';import {useState,useEffect}from'react';import {useDispatch}from'react-redux';import {Modal,Spin}from'antd';import moment from'moment';import {useGetActivityRecordsByDayQuery}from'@admin-layout/activity-client';import {useGetOrganizationClientsQuery}from'@adminide-stack/account-api-client';import {useExtensionController}from'@adminide-stack/extension-module-browser';import {formatDuration}from'../../../services/timeRecordService.js';import {DailyDetailsTable}from'./DailyDetailsTable.js';import*as _ from'lodash';const DailyDetailsModal = (props) => {
    const { selectedDay, visible, onClose, userId, projects, weekStart, members, records } = props;
    const [contributions, setContributions] = useState({});
    const [totalDuration, setTotalDuration] = useState(0);
    const controller = useExtensionController();
    const dispatch = useDispatch();
    const { data: clients, loading: loadClients } = useGetOrganizationClientsQuery();
    const { data, loading, refetch } = useGetActivityRecordsByDayQuery({
        variables: {
            userId,
            date: selectedDay === null || selectedDay === void 0 ? void 0 : selectedDay.format(),
            startTime: weekStart,
            endTime: moment(weekStart).add(1, 'week'),
        },
        skip: !selectedDay
    });
    console.log('selected day-', weekStart === null || weekStart === void 0 ? void 0 : weekStart.format(), selectedDay === null || selectedDay === void 0 ? void 0 : selectedDay.format());
    useEffect(() => {
        console.log('<record-', props.records);
        refetch();
    }, [records, selectedDay]);
    useEffect(() => {
        controller.services.contribution
            .getContributions()
            .subscribe(contribution => {
            setContributions(contribution);
        });
    }, []);
    useEffect(() => {
        if (data) {
            const activityData = _.get(data, 'getActivityRecordsByDay', []);
            const { duration } = activityData.reduce((prev, curr) => ({
                duration: (prev.duration + curr.duration),
            }), { duration: 0 });
            setTotalDuration(duration);
        }
    }, [data]);
    return (React.createElement(Modal, { title: React.createElement("div", null, selectedDay === null || selectedDay === void 0 ? void 0 :
            selectedDay.format('ddd, MMM D, YYYY'),
            ":",
            React.createElement("span", { style: { fontSize: '14px', fontWeight: 400, color: '#787e84' } },
                " ",
                formatDuration(totalDuration))), visible: visible, width: 700, onCancel: onClose, footer: false },
        React.createElement(Spin, { spinning: loading || loadClients },
            React.createElement(DailyDetailsTable, { contributions: contributions, data: _.get(data, 'getActivityRecordsByDay', []), dispatch: dispatch, projects: projects, members: members, clients: _.get(clients, 'getOrganizationClients', []) }))));
};export{DailyDetailsModal};//# sourceMappingURL=DailyDetailsModal.js.map
