import*as React from'react';import {useState,useEffect}from'react';import {Button}from'antd';import ReactExport from'react-export-excel';import moment from'moment';import {useTimeformat}from'../../../hooks/index.js';import {formatDuration}from'../../../services/timeRecordService.js';import {calculateTimeDurationSec}from'@admin-layout/timetracker-core';const ExcelFile = ReactExport.ExcelFile;
const ExcelSheet = ReactExport.ExcelFile.ExcelSheet;
const ExcelColumn = ReactExport.ExcelFile.ExcelColumn;
const ExportExcel = (props) => {
    const { weekStart, approvals, unApprovals, records, projectsMap, getProjectTotalDuration } = props;
    const [columns, setColumns] = useState([]);
    const { timeFormat, dateFormat } = useTimeformat();
    useEffect(() => {
        let cols = ['ProjectName'];
        const days = Array(7)
            .fill(0)
            .map((val, index) => {
            const curDay = moment(weekStart).add(index, 'day');
            return curDay.format(dateFormat);
        });
        cols.push(...days, 'Total');
        setColumns(cols);
    }, [weekStart, dateFormat]);
    const getRecordData = (record, approved) => {
        return record.map((pId) => {
            const project = projectsMap.get(pId);
            let temp = {
                ProjectName: project.name,
                Total: formatDuration(getProjectTotalDuration(project.id, approved), timeFormat),
            };
            Array(7)
                .fill(0)
                .map((val, index) => {
                const curDay = moment(weekStart).add(index, 'day');
                const curDayRecords = records.filter((r) => r.projectId === project.id &&
                    moment(r.startTime).format(dateFormat) === curDay.format(dateFormat) &&
                    !r.timesheetId);
                const duration = curDayRecords.reduce((totalDur, r) => {
                    const dur = calculateTimeDurationSec(r.startTime, r.endTime, r.pauseStatus);
                    return totalDur + Math.abs(dur);
                }, 0);
                temp = Object.assign(Object.assign({}, temp), { [curDay.format(dateFormat)]: formatDuration(duration, timeFormat) });
            });
            return temp;
        });
    };
    const approvedData = getRecordData(approvals, true);
    const unApprovedData = getRecordData(unApprovals, false);
    return (React.createElement(ExcelFile, { element: React.createElement(Button, { type: "primary", style: { float: 'right' } }, "Export timesheet as excel") },
        React.createElement(ExcelSheet, { data: [...approvedData, ...unApprovedData], name: "Timesheet" }, columns.map((col, key) => (React.createElement(ExcelColumn, { key: key, label: col, value: col }))))));
};export{ExportExcel};//# sourceMappingURL=ExportExcel.js.map
