import*as _ from'lodash';import React__default,{useState,useEffect}from'react';import {Spin,message,Row,Col,Switch,Form,Select}from'antd';import TimezonePicker from'react-timezone';import {momentLocalizer}from'react-big-calendar';import {useSelector,useDispatch}from'react-redux';import {useHistory,useLocation}from'react-router';import moment from'moment';export{default as moment}from'moment';import {Subscription,Observable}from'rxjs';import qs__default from'query-string';import {useExtensionController,ViewComponent}from'@adminide-stack/extension-module-browser';import {generateContributionId,parseTemplate,CONTRIBUTION_ACTION_TYPES,COMMAND_ACTION_TYPES,ContributableViewContainer}from'@adminide-stack/extension-api';import TimesheetCalendar from'./Calendar/index.js';import TabularCalendarWrapper from'./Tabular/index.js';import {useGetProjectsQuery,useGetOrganizationMembersQuery,useUpdateTimeRecordMutation,useRemoveTimeRecordMutation}from'@admin-layout/timetracker-core/lib/generated/react-hooks';import {useFirstWeekDay,useViewPermissions}from'../../hooks/index.js';import {ProjectRecord,Activity,Duration,TimeRecord,ActionsComponent}from'./Tabular/DailyDetailsTable.js';import TimesheetModal from'./Calendar/TimesheetModal.js';var view;
(function (view) {
    view[view["CALENDAR_DAY"] = 0] = "CALENDAR_DAY";
    view[view["CALENDAR_WEEK"] = 1] = "CALENDAR_WEEK";
    view[view["CALENDAR_MONTH"] = 2] = "CALENDAR_MONTH";
    view[view["TABULAR_DAY"] = 3] = "TABULAR_DAY";
    view[view["TABULAR_WEEK"] = 4] = "TABULAR_WEEK";
    view[view["TABULAR_MONTH"] = 5] = "TABULAR_MONTH";
})(view || (view = {}));
const Timesheet = ({ projects, members, localizer, weekStart, selectedUser, setSelectedUser, setPathWeekStart, }) => {
    const location = useLocation();
    const history = useHistory();
    const parsed = qs__default.parse(location.search);
    const userId = useSelector((state) => state.user.auth0UserId);
    const [selectedProject, setSelectedProject] = useState('__all');
    const [isShowTimeModal, setIsShowTimeModal] = useState(false);
    //view-id of open view
    const [viewId, setViewId] = useState(null);
    //props to pass in react-element of view
    const [elementProps, setElementProps] = useState({});
    // visibility of client form modal
    const [visible, setVisible] = useState(false);
    const [updateMutation] = useUpdateTimeRecordMutation();
    const [removeMutation] = useRemoveTimeRecordMutation();
    const controller = useExtensionController();
    const subscriptions = new Subscription();
    const dispatch = useDispatch();
    useEffect(() => {
        const id = generateContributionId();
        const contributionPoints = {
            contributions: {
                [id]: {
                    actions: [
                        {
                            id: 'editTimeRecord',
                            title: parseTemplate('Edit record'),
                            command: 'openDialog',
                            commandArguments: ['time-record-dialog', '${eleProps}'],
                        },
                        {
                            id: 'removeTimeRecord',
                            title: parseTemplate('Delete record'),
                            command: 'removeTimeRecord',
                            commandArguments: ['${record}'],
                        },
                    ],
                    menus: {
                        'dailyDetails/menu': [
                            {
                                action: 'editTimeRecord',
                            },
                            {
                                action: 'removeTimeRecord',
                            },
                        ],
                    },
                    tables: {
                        'dailyDetails/table': [
                            { id: 'project', title: 'Project', accessor: 'project', width: 150, cell: ProjectRecord },
                            { id: 'activity', title: 'Activity', accessor: 'activity', width: 80, cell: Activity },
                            { id: 'duration', title: 'Duration', accessor: 'duration', width: 80, cell: Duration },
                            { id: 'time', title: 'Time', accessor: 'time', width: 130, cell: TimeRecord },
                            { title: 'Actions', accessor: 'actions', width: 100, cell: ActionsComponent },
                        ],
                    },
                },
            },
            openTimeRecordModalCommandPayload: {
                command: 'openDialog',
                run: openTimeRecordModal,
            },
            removeTimeRecordCommandPayload: {
                command: 'removeTimeRecord',
                run: removeTimeRecord,
            },
        };
        // register contribution
        dispatch({
            type: CONTRIBUTION_ACTION_TYPES.REGISTER_CONTRIBUTIONS,
            payload: contributionPoints.contributions,
        });
        // register open time record dialog command
        dispatch({
            type: COMMAND_ACTION_TYPES.REGISTER_COMMAND,
            payload: contributionPoints.openTimeRecordModalCommandPayload,
        });
        // register remove time record command
        dispatch({
            type: COMMAND_ACTION_TYPES.REGISTER_COMMAND,
            payload: contributionPoints.removeTimeRecordCommandPayload,
        });
        const options = {
            id: 'time-record-dialog',
            container: ContributableViewContainer.Panel,
        };
        const provider = {
            title: 'Time Record Form',
            content: null,
            priority: 1,
            locationProvider: null,
            reactElement: (React__default.createElement(TimesheetModal, { userId: userId, event: {}, isShowModal: true, members: members, projects: projects, loading: false, handleAddTimeRecordEvent: null, handleUpdateTimeRecordEvent: handleUpdateTimeRecord, handleRemoveTimeRecordEvent: null, handleCloseTimeModal: onClose })),
        };
        const observable = new Observable(observer => { observer.next(provider); });
        controller.services.panelView.registerProvider(options, observable);
        return function unsubscribe() {
            dispatch({
                type: CONTRIBUTION_ACTION_TYPES.DEREGISTER_CONTRIBUTIONS,
                payload: contributionPoints.contributions,
            });
            dispatch({
                type: COMMAND_ACTION_TYPES.DEREGISTER_COMMAND,
                payload: contributionPoints.openTimeRecordModalCommandPayload,
            });
            dispatch({
                type: COMMAND_ACTION_TYPES.DEREGISTER_COMMAND,
                payload: contributionPoints.removeTimeRecordCommandPayload,
            });
            controller.services.panelView.deregisterProvider(options);
            return subscriptions.unsubscribe();
        };
    }, []);
    const handleChangeViewMode = () => {
        parsed.view = parsed.view === 'calendar' ? 'tabular' : 'calendar';
        history.push({
            pathname: location.pathname,
            search: qs__default.stringify(parsed),
        });
    };
    const handleSelectTimezone = (timezone) => {
        // setLocalizer(momentLocalizer(moment.tz.setDefault(timezone)));
    };
    const handleChangeProject = (value) => {
        setSelectedProject(value);
    };
    const handleChangeSelectedUser = (value) => {
        setSelectedUser(value);
    };
    const handleUpdateTimeRecord = (recordId, request) => {
        updateMutation({
            variables: { recordId, request },
            update: (cache, { data, errors }) => {
                if (data) {
                    cache.modify({
                        fields: {
                            getDurationTimeRecords() { },
                            getActivityRecordsByDay() { },
                        }
                    });
                    message.success('A new event has been updated!');
                    setIsShowTimeModal(false);
                }
                else {
                    console.log(errors[0].message);
                    message.error('Event update failed!');
                }
            },
        });
    };
    const removeTimeRecord = (record) => {
        if (record.timesheetId) {
            message.error('Unable to delete record');
        }
        else {
            removeMutation({
                variables: { recordId: record.id },
                update: (cache, { data, errors }) => {
                    if (data) {
                        cache.modify({
                            fields: {
                                getDurationTimeRecords() { },
                                getActivityRecordsByDay() { },
                            }
                        });
                        message.success('Time record deleted');
                    }
                    else {
                        console.log(errors[0].message);
                    }
                }
            });
        }
    };
    const openTimeRecordModal = (id, eleProps) => {
        setViewId(id);
        setVisible(true);
        if (eleProps) {
            setElementProps(eleProps);
        }
    };
    const onClose = () => setVisible(false);
    return (React__default.createElement(React__default.Fragment, null,
        React__default.createElement(ViewComponent, { viewId: viewId, visible: visible, elementProps: elementProps }),
        React__default.createElement(Row, { align: "middle", justify: "space-between", style: { marginBottom: '10px' } },
            React__default.createElement(Col, null,
                React__default.createElement(Switch, { checkedChildren: "Calendar View", unCheckedChildren: "Tabular View", checked: parsed.view === 'calendar', onChange: handleChangeViewMode }))),
        React__default.createElement(Row, { align: "middle", justify: "space-between", style: { marginBottom: '10px' } },
            React__default.createElement(Col, null,
                React__default.createElement("div", { style: { textAlign: 'center' } },
                    React__default.createElement("h3", null, "View & edit timesheets")))),
        React__default.createElement(Row, { align: "middle", gutter: [24, 16] },
            React__default.createElement(Col, { md: 4, xs: 16 },
                React__default.createElement(Form, { labelCol: { span: 20 }, wrapperCol: { span: 20 }, layout: "vertical", className: "sm-screen-size" },
                    React__default.createElement(Form.Item, { label: "Timezone Picker" },
                        React__default.createElement(TimezonePicker, { value: "Asia/Yerevan", onChange: handleSelectTimezone, inputProps: {
                                placeholder: 'Select Timezone...',
                                name: 'timezone',
                            } })))),
            React__default.createElement(Col, { md: 4, xs: 16 },
                React__default.createElement(Form, { labelCol: { span: 20 }, wrapperCol: { span: 20 }, layout: "vertical", className: "sm-screen-size" },
                    React__default.createElement(Form.Item, { label: "Members" },
                        React__default.createElement(Select, { onChange: handleChangeSelectedUser, value: selectedUser },
                            React__default.createElement(Select.Option, { value: "__all", key: "__all" }, "All"),
                            members.map((member) => {
                                return (React__default.createElement(Select.Option, { value: member.userId, key: member.userId }, member.name));
                            }))))),
            React__default.createElement(Col, { md: 4, xs: 16 },
                React__default.createElement(Form, { labelCol: { span: 20 }, wrapperCol: { span: 20 }, layout: "vertical", className: "sm-screen-size" },
                    React__default.createElement(Form.Item, { label: "Projects" },
                        React__default.createElement(Select, { onChange: handleChangeProject, value: selectedProject },
                            React__default.createElement(Select.Option, { value: "__all" }, "All"),
                            projects.map((res) => {
                                return (React__default.createElement(Select.Option, { value: res.id, key: res.id }, res.name));
                            })))))),
        parsed.view === 'calendar' ? (React__default.createElement(TimesheetCalendar, { localizer: localizer, weekStart: weekStart, projects: projects, members: members, isShowTimeModal: isShowTimeModal, selectedUser: selectedUser, selectedProject: selectedProject, setIsShowTimeModal: setIsShowTimeModal, setPathWeekStart: setPathWeekStart })) : (React__default.createElement(TabularCalendarWrapper, { projects: projects, members: members, localizer: localizer, weekStart: weekStart, setPathWeekStart: setPathWeekStart, selectedUser: selectedUser, selectedProject: selectedProject }))));
};
const TimesheetPage = () => {
    const [selectedMember, setSelectedMember] = useState('__all');
    const { data: projectsData, loading: loadingProjects } = useGetProjectsQuery();
    const { data: membersData, loading: loadingMembers } = useGetOrganizationMembersQuery();
    const { value: dowValue } = useFirstWeekDay();
    const history = useHistory();
    const queryParsed = qs__default.parse(location.search);
    const userId = useSelector((state) => state.user.auth0UserId);
    const { self: viewSelfPermit, others: viewOtherPermit } = useViewPermissions();
    useEffect(() => {
        var _a;
        let user = (_a = queryParsed.username) !== null && _a !== void 0 ? _a : (viewSelfPermit === "Allow" /* Allow */ ? userId : '');
        if (!loadingMembers && membersData) {
            const { getOrganizationMembers: members } = membersData;
            if (!(members || []).find((member) => member.userId === user)
                && user !== '__all') {
                user = members[0].userId === userId ?
                    (viewSelfPermit === "Allow" /* Allow */ ? members[0].userId : '__all') :
                    (viewOtherPermit === "Allow" /* Allow */ ? members[0].userId : '__all');
            }
            setSelectedMember(user);
        }
    }, [queryParsed, userId, viewSelfPermit, membersData, loadingMembers]);
    const weekStart = () => {
        return queryParsed.weekStart ? moment(queryParsed.weekStart) : moment().startOf('week');
    };
    // useEffect(() => {
    //   const queryParsed = qs.parse(location.search);
    //   if (queryParsed.strict === undefined || !queryParsed.strict) {
    //     queryParsed.weekStart = moment().startOf('week').format('YYYY-MM-DD');
    //     history.push({
    //       pathname: location.pathname,
    //       search: qs.stringify(queryParsed),
    //     });
    //   }
    // }, [dowValue]);
    const setPathWeekStart = (newWeekStarts) => {
        const parsed = qs__default.parse(location.search);
        parsed.weekStart = moment(newWeekStarts).format('YYYY-MM-DD');
        history.push({
            pathname: location.pathname,
            search: qs__default.stringify(parsed),
        });
    };
    const setSelectedUser = (username) => {
        const parsed = qs__default.parse(location.search);
        parsed.username = username;
        history.push({
            pathname: location.pathname,
            search: qs__default.stringify(parsed),
        });
    };
    moment.locale('en', {
        week: {
            dow: dowValue,
        },
    });
    const localizerM = momentLocalizer(moment);
    const filteredProjects = () => {
        return [..._.get(projectsData, 'getProjects', []), { id: '', name: 'UnKnown' }];
    };
    const filteredMembers = () => {
        return _.get(membersData, 'getOrganizationMembers', []).filter((member) => {
            if (viewOtherPermit === "Allow" /* Allow */ && member.userId !== userId)
                return true;
            if (viewSelfPermit === "Allow" /* Allow */ && member.userId === userId)
                return true;
            return false;
        });
    };
    return (React__default.createElement(Spin, { spinning: loadingProjects || loadingMembers },
        React__default.createElement(Timesheet, { projects: filteredProjects(), members: filteredMembers(), localizer: localizerM, weekStart: weekStart(), selectedUser: selectedMember, setPathWeekStart: setPathWeekStart, setSelectedUser: setSelectedUser })));
};export default TimesheetPage;export{view};//# sourceMappingURL=index.js.map
