import*as React from'react';import {useEffect}from'react';import {useDispatch}from'react-redux';import {EditTwoTone}from'@ant-design/icons';import {generateContributionId,CONTRIBUTION_ACTION_TYPES}from'@adminide-stack/extension-api';import {Payments}from'./components/Payments/Payments.js';import {Limits}from'./components/Limits/Limits.js';import HeaderTimerHandler from'./components/HeaderTimerHandler/index.js';import {LanguageMenu}from'@admin-layout/react-shared-components';const EditableComponent = (props) => {
    return (React.createElement("div", null,
        React.createElement("div", { style: { float: 'left' } }, "-"),
        React.createElement(EditTwoTone, { style: { float: 'right', margin: '5px' } })));
};
const RegisterContribution = () => {
    const dispatch = useDispatch();
    useEffect(() => {
        const id = generateContributionId();
        const teamsContribution = {
            [id]: {
                tables: {
                    'member/table': [
                        {
                            id: 'payment',
                            title: 'Payment',
                            accessor: 'actions',
                            width: 150,
                            position: 3,
                            cell: Payments,
                        },
                        {
                            id: 'limits',
                            title: 'Limits',
                            accessor: 'actions',
                            width: 100,
                            position: 3,
                            cell: Limits,
                        },
                        {
                            id: 'timeTracking',
                            title: 'Time Tracking',
                            accessor: 'timeTracking',
                            width: 100,
                            position: 3,
                            cell: EditableComponent,
                        },
                    ],
                },
                pageNavBar: [
                    { name: 'header-timer', position: 'right', priority: 1, component: () => React.createElement(HeaderTimerHandler, null) },
                    { name: 'language-menu', position: 'right', priority: 2, component: () => React.createElement(LanguageMenu, null) },
                ],
            },
        };
        // register contribution
        dispatch({
            type: CONTRIBUTION_ACTION_TYPES.REGISTER_CONTRIBUTIONS,
            payload: teamsContribution,
        });
    }, []);
    return null;
};export{RegisterContribution};//# sourceMappingURL=register-contribution.js.map
