import moment from'moment';import momentDurationFormatSetup from'moment-duration-format';momentDurationFormatSetup(moment);
/**
 * Format seconds to time
 *
 * @param seconds
 * @return hh:mm:ss
 */
const formatDuration = (sec, timeFormat) => {
    const seconds = Math.abs(sec);
    const duration = moment.duration(seconds, 'seconds');
    return duration.format(timeFormat || 'HH:mm:ss', { trim: false }).replace(/[A | A]/gi, '');
};
/**
 * Get duration from time string formated hh:mm:ss
 * @param str
 * @return seconds
 */
const stringToDuration = (str) => {
    const digits = str.split(':');
    const len = digits.length;
    let totalSeconds = 0;
    if (len === 1)
        totalSeconds = parseInt(digits[0]);
    else if (len === 2) {
        totalSeconds = parseInt(digits[0]) * 60 + parseInt(digits[1]);
    }
    else if (len === 3) {
        totalSeconds = parseInt(digits[0]) * 3600 + parseInt(digits[1]) * 60 + parseInt(digits[2]);
    }
    else
        return 0;
    return totalSeconds;
};
/**
 *
 * @param duration Number of duration
 * @param roundSeconds Number of seconds
 * @param method Enum of { "ceil", "floor", "round" }
 * @returns roundedDuration
 */
function roundDuration(duration, roundSeconds, method) {
    return Math[method](Math.abs(+duration) / +roundSeconds) * +roundSeconds;
}
/**
 * Return seconds from timestring
 * @param str:string
 * @returns
 */
const getSecsFromString = (str) => {
    const [str1, str2, str3] = str.split(':');
    const val1 = Number(str1);
    const val2 = Number(str2);
    const val3 = Number(str3);
    if (!isNaN(val1) && isNaN(val2) && isNaN(val3)) {
        return val1 * 60;
    }
    if (!isNaN(val1) && !isNaN(val2) && isNaN(val3)) {
        return val1 * 60 * 60 + val2 * 60;
    }
    if (!isNaN(val1) && !isNaN(val2) && !isNaN(val3)) {
        return val1 * 60 * 60 + val2 * 60 + val3;
    }
    return 0;
};export{formatDuration,getSecsFromString,roundDuration,stringToDuration};//# sourceMappingURL=timeRecordService.js.map
